2017-06-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/cert-tests/Makefile.am: tests: corrected typo in makefile Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-06-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, configure.ac, m4/hooks.m4: released 3.5.13 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-06-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: fix DER export with --p7-info Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-06-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-tests/Makefile.am,
	tests/cert-tests/data/openssl-invalid-time-format.pem,
	tests/cert-tests/tolerate-invalid-time, tests/strict-der.c: tests:
	added unit test to verify that certificates with non-DER strict time
	fields are accepted Also removed the old strict compliance DER test.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/common.h: Tolerate DER time encoding errors It seems that openssl generated certificates may contain invalid
	formatted times, and gnutls will no longer parse them. Ignore such
	formatting errors when DER decoding.  We should reconsider this in the future (#207) Resolves #196 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c: GNUTLS_E_INSUFFICIENT_SECURITY: moved to fatal
	errors Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/minitasn1/decoding.c, lib/minitasn1/element.c,
	lib/minitasn1/errors.c, lib/minitasn1/libtasn1.h,
	lib/minitasn1/parser_aux.c: libtasn1: updated to 4.11 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/scripts/common.sh, tests/slow/Makefile.am,
	tests/slow/test-ciphers-common.sh, tests/slow/{test-hash-large =>
	test-hash-large.sh}: tests: skip x86-specific tests when not in x86 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure: warn when building as static library [ci
	skip] Relates #203 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c: 
	gnutls_ocsp_status_request_enable_client: documented requirements
	for parameters That is, the fact that extensions and responder_id parameters must
	be allocated, and are assigned to the session.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c: ext/status_request: Removed the parsing
	of responder IDs from client extension These values were never used by gnutls, nor were accessible to
	applications, and as such there is not reason to parse them.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c: ext/status_request: ensure response IDs
	are properly deinitialized That is, do not attempt to loop through the array if there is no
	array allocated.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-23  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/crypto-selftests.c: self-tests: limit compatibility API checks
	to vectors with plaintext Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/slow/cipher-override.c: tests: on cipher override do not run
	the compatibility checks That is, because we introduce a cipher using the new AEAD API which
	does not provide compatibility hooks.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-selftests.c, lib/includes/gnutls/self-test.h: 
	self-tests: introduced flag GNUTLS_SELF_TEST_FLAG_NO_COMPAT This allows skipping the compatibility APIs when running self tests.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-selftests-pk.c, lib/crypto-selftests.c,
	lib/includes/gnutls/self-test.h: self-tests: all parameter was
	replaced by flags This allows to introduce more options than just check all ciphers.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/accelerated/aarch64/aes-gcm-aarch64.c: aarch64: fix AES-GCM
	in-place encryption and decryption Resolves #204 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-selftests.c: crypto: self-tests: enhance to include
	compatibility APIs That is, run the compatibility gnutls_cipher_* APIs on self tests
	for AEAD ciphers in addition to the AEAD API.  Relates #204 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/algorithms/ciphers.c, lib/crypto-api.c, lib/gnutls_int.h: 
	crypto-api: refuse to run gnutls_cipher_init() in full AEAD modes That is, there are AEAD modes like CCM that can only be used through
	the AEAD API. Always refuse calls to gnutls_cipher_init() in these
	modes.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey.c: doc: corrected error in
	gnutls_x509_privkey_sign_data parameters [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-16  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-08  Karl Tarbe <karl.tarbe@cyber.ee>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/pkcs7-chain-endcert-key.pem,
	tests/cert-tests/data/pkcs7-chain-root.pem,
	tests/cert-tests/data/pkcs7-chain.pem,
	tests/cert-tests/pkcs7-list-sign: tests: add test for signing with
	certificate list Signing with one certificate, but includes the other certificates
	inside the PKCS#7 structure.  Signed-off-by: Karl Tarbe <karl.tarbe@cyber.ee>

2017-05-04  Karl Tarbe <karl.tarbe@cyber.ee>

	* src/certtool-args.def, src/certtool.c: certtool: allow multiple
	certificates in --p7-sign Signed-off-by: Karl Tarbe <karl.tarbe@cyber.ee>

2017-05-12  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/pkcs7.c: find_signer: eliminate memory leak Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-14  Andreas Metzler <ametzler@bebt.de>

	* m4/hooks.m4: Fix autoconf progress message concerning heartbeat
	[ci skip]

2017-05-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/x509_dn.c: doc: corrected typo [ci skip] Reported by Andreas Metzler.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/openpgp-callback.c: test: corrected typo preventing the run
	of openpgp test [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, m4/hooks.m4: released 3.5.12 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11x.c: pkcs11_override_cert_exts: do not use
	CKA_X_DISTRUSTED flag when retrieving This flag was introduced in order for reducing the number of
	duplicate stapled extensions returned by p11-kit. Unfortunately that
	fix was bogus and in fact it resulted to p11-kit not returning any
	stapled extensions.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, src/cli-args.c.bak, src/cli-args.h.bak,
	src/cli-debug-args.c.bak, src/danetool-args.c.bak: updated
	auto-generated files Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* Makefile.am, configure.ac: Makefile: files-update directive will
	update the auto-generated files in src/ This simplifies the update of files generated by autogen.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/sni-hostname.sh: tests: added check for
	gnutls-cli's sni-hostname option Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/cli-args.def, src/cli.c: gnutls-cli: introduced --sni-hostname
	option This allows overriding the value set on the TLS server name
	indication extension.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-23  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/extensions.c, lib/includes/gnutls/gnutls.h.in: gnutls.h:
	introduced flag GNUTLS_EXT_FLAG_OVERRIDE_INTERNAL [ci skip] This flag is expected to be used by applications which handle custom
	extensions that are not currently supported in gnutls, but support
	for them may be added in the future.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/errors.h: errors.h: _gnutls_cert_log will only print on
	non-null certificates Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-05-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-28  Nicolas Dufresne <nicolas.dufresne@collabora.com>

	* lib/auth/rsa_psk.c: rsa-psk: Use the correct username datum In rsa-psk we properly request username for the case the application
	uses a callback, but later we use the username cached in the
	credentials structure. This will lead to empty username issues.  Signed-off-by: Nicolas Dufresne <nicolas.dufresne@collabora.com>

2017-05-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/rsa-psk-cb.c: tests: added check for PSK
	client callback in RSA-PSK This check verifies whether gnutls_psk_client_credentials_function
	is operational, and the parameters sent are taken into account by
	the server.  Relates !364 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/{mini-rsa-psk.c => rsa-psk.c}: tests:
	simplified name of mini-rsa-psk check In addition modernize the used APIs and added explicit check on the
	received by the server username value.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/arb-extensions.csr,
	tests/cert-tests/data/arb-extensions.pem,
	tests/cert-tests/templates/arb-extensions.tmpl: tests: utilize the
	email_protection_key template option This ensures that generated certificates and requests will include
	that key purpose when the option is present.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-cfg.c, src/certtool-cfg.h, src/certtool.c: certtool:
	introduced the email_protection_key option This option was introduced in documentation for certtool without an
	implementation of it. It is a shortcut for option key_purpose_oid =
	1.3.6.1.5.5.7.3.4 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-05-01  Andreas Metzler <ametzler@bebt.de>

	* src/socket.c: gnutls-cli: Use CRLF with --starttls-proto=smtp.  Closes https://gitlab.com/gnutls/gnutls/issues/200

2017-05-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-idna.c: tests: don't use GNUTLS_IDNA_FORCE_2008 in
	str-idna Instead utilize the default flags to allow fallback to IDNA2003.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/hostname-check.c: tests: enhance with checks to verify that
	textual IPs are not matched That verifies that the hostname check verification function will not
	succeed if given textual IPs, and the certificate contains textual
	IPs in DNSname or in the CN fields.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/hostname-verify.c: gnutls_x509_crt_check_hostname2: no
	match dns fields against IPs Previously we were checking textual IP address matching against the
	DNS fields. This match was non-standard and was intended to work
	around few broken servers. However that also led to not evaluating
	and IP constraints for that IP. No longer follow that broken
	behavior.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-idna.c: tests: check against symbols present only in
	IDNA2003 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str-idna.c: gnutls_idna_map: fallback to IDNA2008 transitional
	encoding on failure This aligns with the behavior of firefox, which maps to IDNA2008,
	and fallbacks to IDNA2003 if that fails (e.g., mapping doesn't
	exist).  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-gtls-app.texi, lib/locks.c: doc: clarifications on custom
	thread override [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS, configure.ac, m4/hooks.m4: bumped version [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-10  Tim Rühsen <tim.ruehsen@gmx.de>

	* devel/openssl, lib/system/fastopen.c: lib/system/fastopen: Add TCP
	Fast Open for OSX Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>

2017-04-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/state.c: doc: removed incorrect comment Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/dh-session.c: gnutls_dh_get_pubkey: fixed operation under PSK
	authentication Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/dh.c, lib/randomart.c: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/doc.mk, lib/anon_cred.c, lib/openpgp/openpgp.c,
	lib/supplemental.c, lib/x509/crq.c, lib/x509/dn.c,
	libdane/dane-params.c: doc: fixed documentation for various function
	parameters [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/trust-store.c: tests: use gnutls_global_init instead of
	global_init The reason is to force initialization of the PKCS#11 backend, and
	thus support for any PKCS#11 trust store when setup.  This fixes
	running the test suite in Fedora.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am: doc: fixed tpmtool and psktool documentation Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509/output: do not print usage entry when
	there is none Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-common.c, src/common.c, src/common.h: certtool:
	improved printing of the key PIN and key ID That is, on private keys use the same format when printing the
	public Key ID and public key PIN, as when printing it in
	certificates.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-common.c, src/certtool.c, src/common.c, src/common.h: 
	certtool: print the key PIN on private and public keys Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509_b64.c: gnutls_pem_base64_encode2: do raw base64 when msg
	is NULL This change is undocumented for now (intended for 3.6.0).  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/dtls/Makefile.am, tests/dtls/dtls-stress.c: tests:
	dtls-stress: use X.509 certificates instead of openpgp This will allow the test tool to operate even after openpgp
	certificates are deprecated.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/openpgp-callback.c: tests: do not run tests which require
	openpgp when it is disabled Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: backported and simplified CI setup This makes builds independent by reducing interactions between
	artifacts of builds.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update [ci skip]

2017-04-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, configure.ac, m4/hooks.m4: released 3.5.11

2017-03-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/Makefile.am, lib/openpgp_compat.c: Added openpgp stub file That allows disabling openpgp authentication and at the same time
	retaining ABI compatibility with versions including openpgp.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/trust-store.c: tests: added basic check
	for system trust store This checks whether the gnutls_certificate_set_x509_system_trust()
	and thus the trust list equivalent function operate as expected and
	return a positive number of certificates. The test is ignored in
	systems where these functions return GNUTLS_E_UNIMPLEMENTED_FEATURE.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-04-04  David Caldwell <david@porkrind.org>

	* configure.ac, lib/Makefile.am, lib/system/certs.c: 
	gnutls_x509_trust_list_add_system_trust: Add macOS keychain support Also don't check for a default_trust_store_file in configure when
	building on macOS (unless explicitly asked to with
	--with-default-trust-store-file=xxx), because otherwise it finds
	/etc/ssl/cert.pem: This file is new (since 10.12.2?), which means
	libraries built on the newest OS version wouldn't work the same way
	on an older versions (and vice versa).  "/etc/ssl/cert.pem" also
	doesn't seem to reflect additions and deletions from the user's or
	system's trusted roots keychain (in my limited testing).  Signed-off-by: David Caldwell <david@porkrind.org>

2017-04-05  David Caldwell <david@porkrind.org>

	* lib/buffers.c, lib/buffers.h, lib/cipher.c, lib/cipher.h,
	lib/dtls-sw.c, lib/dtls.h, lib/gnutls_int.h, lib/num.c, lib/num.h,
	lib/record.c, tests/dtls-sliding-window.c: Rename uint64 to
	gnutls_uint64 to avoid conflict with macOS Signed-off-by: David Caldwell <david@porkrind.org>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: fixed newline skip code in smime-to-p7
	code Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify.c: is_level_acceptable: ensure issuer is not
	dereferenced when null Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: guard the value of tl before
	gnutls_pkcs7_verify This utilizes assert() as it cannot be triggered in practice.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crl.c, lib/x509/crq.c, lib/x509/dn.c,
	lib/x509/extensions.c, lib/x509/ocsp.c, lib/x509/pkcs12.c,
	lib/x509/pkcs7.c, lib/x509/x509.c, lib/x509/x509_dn.c,
	lib/x509/x509_ext.c, lib/x509/x509_int.h: Avoid using
	ASN1_MAX_NAME_SIZE directly Since ASN1_MAX_NAME_SIZE refers to a single element in the asn1
	tree, it is not suitable to hold the maximum combined name. Instead
	use a local definition of MAX_NAME_SIZE, which is a multiple of the
	ASN1_MAX_NAME_SIZE.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crq.c: gnutls_x509_crq_set_challenge_password: don't
	accept null password Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crl_write.c, lib/x509/key_encode.c, lib/x509/ocsp.c,
	lib/x509/pkcs7.c, lib/x509/x509_ext.c, lib/x509/x509_write.c: Mark
	with (void) the functions where the returned value is not checked
	intentionally This allows static analysers to properly warn on unchecked return
	values.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str-idna.c: removed duplicate code Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/handshake.c, lib/record.c: handshake/record: mark with
	comments all expected fall-through switches This reduces warnings from static analysers like coverity and makes
	explicit the intention.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/gnutlsxx.cpp: gnutlsxx.cpp: fixed misleading indentation
	issues Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/heartbeat.c: doc: document intended fallthrough Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/utils.c: tests: fixed possible buffer overflow to avoid
	spurious complaints Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system_override.c: gnutls_transport_set_pull_timeout_function:
	doc update [ci skip] Clarified when this function should be set. Based on suggestion by
	Sean Greenslade.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-04-02  Andreas Metzler <ametzler@bebt.de>

	* extra/gnutls_openssl.c: Use NORMAL priority for SSLv23_*_method.  Instead of enforcing TLS1.0/SSL3.0 use gnutls NORMAL priority for
	SSLv23_*_methods.  http://bugs.debian.org/857436

2017-03-31  Matt Turner <mattst88@gmail.com>

	* tests/cert-tests/krb5-test: tests: Copy template out of ${srcdir} Otherwise, out of tree builds will fail to copy the template.  Signed-off-by: Matt Turner <mattst88@gmail.com>

2017-03-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/pkcs12-corner-cases: tests: added checks with
	problematic PKCS#12 files These check whether parsing of unsupported files (e.g., with
	RC2-128), will succeed. This serves as functionality check for
	gnutls_pkcs8_info.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey_pkcs8.c: gnutls_pkcs8_info: do not free oid on
	GNUTLS_E_UNKNOWN_CIPHER_TYPE The documented behavior of the function was to return a valid OID in
	that case.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-30  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-tokens.texi: doc update [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-26  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .travis.yml: .travis.yml: no longer install pkg-config Travis build seem to fail for some reason since pkg-config is
	already installed.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-26  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/ocsp-tests/Makefile.am: ocsp-test: disable under windows This test was failing because datefudge couldn't run under win32.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-26  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/ocsp-tests/ocsp-test: Revert "ocsp-test: disable under
	windows" This reverts commit 90d5ad5a42759957866ba1d9c96f5dccfd3ea1cc.

2017-03-26  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/ocsp-tests/ocsp-test: ocsp-test: disable under windows This test was failing because datefudge couldn't run under win32.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-25  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: increase time of artifact
	expiration This allows to re-run failed builds on the depending stages during
	that time.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-25  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/gnutls.pc.in: gnutls.pc: Removed P11_KIT_LIBS from
	Libs.private It was already being included in Requires.private. Reported by
	Andreas Metzler.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/gnutls.pc.in: gnutls.pc: don't include zlib
	twice in private libs

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/privkey-verify-broken.c: tests: added
	unit test of gnutls_pubkey_verify_data2 override flags Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/cert.c: _gnutls_check_key_cert_match: allow broken sigs That ensures that when loading a certificate pair with SHA1, when
	SHA1 is disabled will not cause the server to fail to load.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pubkey.c, lib/x509/verify.c, lib/x509/x509_int.h: Use a common
	function to decide acceptable signatures That is, ensure that results from all verification functions,
	including gnutls_pubkey_verify_data2(), will be consistent with SHA1
	and other algorithms deprecation.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509.c: check_ocsp_response: utilize the same flags as in
	certificate verification That ensures that overrides like using broken algorithms are
	considered in OCSP validation.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-18  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/pkgconfig.sh: tests: added script to
	check pkg-config operation That is, whether the generated gnutls.pc will function for compiling
	and linking.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-18  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/gnutls.pc.in: gnutls.pc: don't pass the libtool vars to
	Libs.private Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/tls-rehandshake-cert-2.c, tests/tls-rehandshake-cert.c: 
	tests: improved tls-rehandshake tests Used common definitions from cert-common.h for certificates, and
	improved error detection in tls-rehandshake-cert-2.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/tls-rehandshake-cert-3.c: tests: check
	whether a rehandshake without a cert works That is, check whether if on initial handshake the server requests a
	certificate, but on the following rehandshake he doesn't, whether
	the client behaves as expected. This tests:
	1f685db853db6e48c77c6dbde0cdf716a7303baa Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/auth/cert.c, lib/cert-session.c, lib/gnutls_int.h,
	lib/handshake.c, lib/kx.c: handshake: reset cert request state on
	handshake init That addresses a bug which on client side on case of an initial
	handshake with a client certificate, we continue to send this
	certificate even if on rehandshake we were not requested with on.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-17  Martin Storsjo <martin@martin.st>

	* lib/includes/gnutls/openpgp.h: Avoid deprecation warnings when
	including gnutls/abstract.h Since ac3de8f5, when all openpgp functionality was deprecated, a
	library user including gnutls/abstract.h gets warnings about
	deprecated declarations, like this: gnutls/openpgp.h:328:10: warning: ‘gnutls_openpgp_recv_key_func’
	          is deprecated [-Wdeprecated-declarations]
	gnutls_openpgp_recv_key_func func) _GNUTLS_GCC_ATTR_DEPRECATED; This warning is emitted since the
	gnutls_openpgp_set_recv_key_function prototype uses the deprecated
	typedef gnutls_openpgp_recv_key_func.  By omitting the deprecation attribute from this individual typedef,
	we avoid the spurious warnings in calling code which just includes
	gnutls/abstract.h without actually using anything related to
	openpgp.  Signed-off-by: Martin Storsjo <martin@martin.st>

2017-03-15  Martin Storsjo <martin@martin.st>

	* m4/hooks.m4: Fix a typo in a variable name in an m4 script Signed-off-by: Martin Storsjo <martin@martin.st>

2017-03-14  Alon Bar-Lev <alon.barlev@gmail.com>

	* .gitlab-ci.yml, configure.ac, gl/m4/valgrind-tests.m4,
	gl/override/m4/valgrind-tests.m4.diff: build: disable valgrind tests
	by default Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-03-13  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/Makefile.am: build: tests: resolve as-needed issue with
	seccomp Incorrect ordering of -lseccomp: <snip> -Wl,--as-needed
	../lib/.libs/libgnutls.so -lseccomp ./.libs/libutils.a
	./.libs/libutils.a(seccomp.o): In function seccomp_init'
	seccomp.c:(.text+0x2b): undefined reference to `seccomp_init' <snip> Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-03-13  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/pkcs11_privkey.c, lib/privkey.c: gnutls_pkcs11_privkey_init:
	document limitation on created object Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11_privkey.c: pkcs11: re-open privkey session handle on
	CKR_SESSION_HANDLE_INVALID When initializing a private key operation, attempt to re-open the
	key if CKR_SESSION_HANDLE_INVALID is received.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/pkcs11/pkcs11-privkey-pthread.c: tests:
	introduced check for parallel operation (signatures) in PKCS#11 mode That is, verify that parallel signatures using a single
	gnutls_pkcs11_privkey_t context work.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11.c, lib/pkcs11_int.h, lib/pkcs11_privkey.c: pkcs11:
	re-open private key session inside a locked section This prevents clashes when the same operation is carried in other
	threads.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11_privkey.c: pkcs11: introduced locks to PKCS#11 private
	key structure This allows to run PKCS#11 private key operations such as signing
	and decryption in parallel.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* m4/ax_code_coverage.m4: ax_code_coverage.m4: updated [ci skip] Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-13  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/cert-tests/openpgp-certs: tests: cert-tests: openpgp-certs:
	align test redirection Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-03-13  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/cert-tests/suppressions.valgrind,
	tests/key-tests/suppressions.valgrind,
	tests/ocsp-tests/suppressions.valgrind,
	tests/suite/suppressions.valgrind,
	tests/suite/x509paths/suppressions.valgrind,
	tests/suppressions.valgrind: tests: suppressions.valgrind: supress
	fillin_rpath Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-03-13  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/openpgp-certs/suppressions.valgrind: tests: remove unused
	suppressions.valgrind Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-03-12  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/scripts/common.sh: tests: scripts: suppress which errors Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-03-12  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-11  Alex Gaynor <alex.gaynor@gmail.com>

	* lib/opencdk/keydb.c, tests/cert-tests/openpgp-cert-parser: Do not
	attempt to parse a 32-bit integer if a packet is not 4 bytes.  This addresses:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=824 Signed-off-by: Alex Gaynor <alex.gaynor@gmail.com>

2017-03-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-08  Alex Gaynor <alex.gaynor@gmail.com>

	* lib/opencdk/keydb.c, tests/cert-tests/openpgp-cert-parser: Do not
	attempt to parse a 32-bit integer if a packet is not 4 bytes.      This addresses:       https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=737 Signed-off-by: Alex Gaynor <alex.gaynor@gmail.com>

2017-03-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am: Makefile.am: Added missing file Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2017-03-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: execute initialization stage
	unconditionally This step is required both in tags and commit runs.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, configure.ac, m4/hooks.m4: bumped version Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/datum.c: _gnutls_set_strdatum: always return an allocated
	string on success That prevents returning NULL to functions which require a string.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-05  Alex Gaynor <alex.gaynor@gmail.com>

	* lib/opencdk/read-packet.c, tests/cert-tests/openpgp-cert-parser: 
	Enforce the max packet length for OpenPGP subpackets as well This addresses:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=392 Signed-off-by: Alex Gaynor <alex.gaynor@gmail.com>

2017-03-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-cert-auth2.texi: doc: corrected typo [ci skip] It was pointed out by morozov@eags.ru.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: NEWS: added links to GNUTLS-SA-2017-3

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: run tests under a FIPS140 mode
	simulation That is, in FIPS140-2/Fedora/x86_64 build, run tests under a normal
	run (when library is compiled with FIPS140-2 support but not enabled
	on run time), and also run tests under a run-time that simulates
	FIPS140-2 support.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-selftests.c: crypto-self-tests: modified exported
	functions to work under fips140-2 mode Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/dtls1-2-mtu-check.c, tests/key-tests/Makefile.am,
	tests/set_x509_pkcs12_key.c, tests/x509sign-verify2.c: tests: skip
	tests which cannot be run in FIPS140-2 mode This allows the test suite to be run in FIPS140-2 mode.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pk.c: _gnutls_pk_params_copy: copy the provable algorithm used This is affected utilization of generated RSA keys under FIPS140-2
	mode which utilizes provable generation.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/priorities.c: tests: priorities: skip test in FIPS140-2 mode Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/session_ticket.c: gnutls_session_ticket_key_generate:
	fixed operation under FIPS140-2 mode Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-03-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-03-01  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/openpgp-cert-parser: tests: added test cases with
	invalid openpgp certs These certificates contain invalid secret key sub-packets.  These
	  trigger invalid memory accesses:
	https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=360   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=354 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-03-01  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/opencdk/kbnode.c, lib/opencdk/keydb.c, lib/opencdk/literal.c,
	lib/opencdk/opencdk.h, lib/opencdk/read-packet.c,
	lib/openpgp/openpgp.c, lib/openpgp/pgp.c, lib/openpgp/privkey.c: 
	opencdk: do not parse any secret keys in packet when reading a
	certificate This reduces the attack surface on the parsers, and prevents any
	bugs in the secret key parser to be exploitable by inserting secret
	key sub-packets into an openpgp certificate.  This addresses:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=354   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=360 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509/output: Cleanup in IDNA name printing That also removes the incorrect mapping to IDNA punycode when the
	input is not printable.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-cfg.c: certtool: increased buffer for reading from
	user This allows reading longer than 128-byte fields interactively.  The
	new limit is 512-bytes.  Relates #179 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-cfg.c: certtool: store critical extensions even if no
	other extension are present That is, fix a bug which prevented critical extensions to be stored
	if no other free-form extensions were specified.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-02-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/ocsp.c: gnutls_ocsp_resp_verify_direct,
	gnutls_ocsp_resp_verify: defined flags argument That was defined to be gnutls_certificate_verify_flags, and it
	allows passing verification flags, such as flags to allow broken
	algorithms.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify.c: is_level_acceptable: no longer checks for
	broken algorithms This is done at is_broken_allowed(), and in fact checking them in
	is_level_acceptable() creates a conflict when overrides like flag
	GNUTLS_VERIFY_ALLOW_BROKEN is used.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/gnutls.h.in, lib/verify-tofu.c: 
	gnutls_store_commitment: introduced flag
	GNUTLS_SCOMMIT_FLAG_ALLOW_BROKEN This flag allows operation of the function even with broken
	algorithms.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify.c: verify: is_broken_allowed: account for "new"
	flag GNUTLS_VERIFY_ALLOW_BROKEN Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/openpgp-cert-parser: tests: added test case with
	invalid openpgp cert This triggers an invalid memory access:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=391 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/read-packet.c: opencdk: read_attribute: account buffer
	size That ensures that there is no read past the end of buffer.  Resolves the oss-fuzz found bug:
	https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=391 Relates: #159 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/socket.c: gnutls-cli-debug: fixed protocol to port discovery That is, if --starttls-proto is provided the default port selected
	will be converted to host byte order as expected.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: NEWS: fix typo [ci skip]

2017-02-22  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, tests/Makefile.am, tests/scripts/Makefile.am,
	tests/scripts/starttls-common.sh, tests/starttls-ftp.sh,
	tests/starttls-lmtp.sh, tests/starttls-nntp.sh,
	tests/starttls-pop3.sh, tests/starttls-sieve.sh,
	tests/starttls-smtp.sh, tests/starttls.sh: tests: split starttls.sh
	into multiple scripts Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-02-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/data/aki-cert.pem,
	tests/cert-tests/data/arb-extensions.csr,
	tests/cert-tests/data/bmpstring.pem,
	tests/cert-tests/data/ca-no-pathlen.pem,
	tests/cert-tests/data/complex-cert.pem,
	tests/cert-tests/data/long-oids.pem,
	tests/cert-tests/data/multi-value-dn.pem,
	tests/cert-tests/data/name-constraints-ip2.pem,
	tests/cert-tests/data/no-ca-or-pathlen.pem,
	tests/cert-tests/data/template-tlsfeature.csr,
	tests/cert-tests/data/very-long-dn.pem,
	tests/cert-tests/data/xmpp-othername.pem: tests: updated to include
	the pin-sha256 in output Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/dn2.c: tests: updated to take into account the pin-sha256
	oneline output Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509/output: print key PIN on oneline output That is, instead of the public key ID. The key PIN due to HPKP is
	now more widely used than hex-based key IDs.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str.c, lib/str.h, lib/x509/output.c: x509/output: print the
	public key PIN of a certificate That is, print the value used by the HPKP protocol as per RFC7469.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-22  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/pkcs11/pkcs11-import-with-pin.c: tests:
	pkcs11-import-with-pin: removed invalid conditional macro

2017-02-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/pkcs11/pkcs11-import-with-pin.c: tests:
	added PKCS#11 test for pin input This introduces a test on PIN input to retrieve an object using
	pin-value and pin-source (file).  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-22  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: ubsan build: fixed artifacts path Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-cfg.c: certtool: don't warn when 'uri' is specified
	on template Reported at: https://bugzilla.redhat.com/show_bug.cgi?id=1425884 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/pk.c: nettle/pk: corrected memcpy of Q in DSA params Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: backported from master branch Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac: configure: no longer use -Wframe-larger-than We do not require a specific stack size, and there is legacy code
	which utilizes large stack sizes. As such remove the warnings to
	allow for a warning free compilation.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/pkcs11.c: pkcs11: avoid calling memcpy will null options Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7.c: pkcs7: corrected error checking in
	write_signer_id Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/common.c: make_printable_string: allow operation with
	null input Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/gnutls_int.h: gnutls_int.h: include assert.h Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/openpgp-invalid5.pub,
	tests/cert-tests/openpgp-cert-parser: tests: added test case with
	invalid openpgp cert That triggers a heap buffer overflow:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=420 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/read-packet.c: opencdk/read-packet.c: corrected typo
	in type cast Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/read-packet.c: cdk_pkt_read: enforce packet limits That ensures that there are no overflows in the subsequent
	calculations.  Resolves the oss-fuzz found bug:
	https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=420 Relates: #159 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-02-19  Robert Scheck <robert@fedoraproject.org>

	* src/cli-args.def, src/cli-debug-args.def, src/danetool-args.def,
	src/socket.c, tests/Makefile.am, tests/starttls-lmtp.txt,
	tests/starttls-nntp.txt, tests/starttls-pop3.txt,
	tests/starttls-sieve.txt, tests/starttls.sh: Add LMTP, POP3, NNTP,
	Sieve and PostgreSQL support to gnutls-cli Add LMTP (RFC 2033), POP3 (RFC 2595), NNTP (RFC 4642), Sieve (RFC
	5804) and PostgreSQL support to gnutls-cli ("--starttls-proto").  Signed-off-by: Robert Scheck <robert@fedoraproject.org>

2017-02-17  Rical Jasan <ricaljasan@pacific.net>

	* tests/scripts/common.sh: tests: Improve port-checking
	infrastructure.  The test suite unnecessarily failed on systems without netstat
	because it was assumed to be present.  Instead of simply checking
	for its presence and indicating an unsupported test, however, the ss
	utility can be used as a drop-in replacement.  When
	netstat/net-tools is not present, the ss utility from iproute2 still
	stands a fair chance of existing, and they also have similar enough
	semantics that they can be used interchangeably in the test suite.  The functions in tests/scripts/common.sh that used netstat (wait_for_port, wait_for_free_port) now use new functions,
	check_if_port_in_use and check_if_port_listening, to abstract the
	call to netstat/ss.  The eval'd variable GETPORT also used netstat,
	and has been updated accordingly.  The new port-checking functions use another new function,
	have_port_finder, which takes care of the details of selecting ss (preferred) or netstat, or fails otherwise.  Signed-off-by: Rical Jasan <ricaljasan@pacific.net> Signed-off-by:
	Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-12  Alon Bar-Lev <alon.barlev@gmail.com>

	* doc/Makefile.am: build: doc: install images also into htmldir images are required also by the html documentation.  Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-02-15  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2017-02-15  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, lib/gnutls.pc.in: gnutls.pc: do not include libidn2
	in Requires.private The libidn2 versions available do not include libidn2.pc, thus the
	inclusion was causing problems when using pkg-config.  Instead we
	include -lidn2 in Libs.private.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-02  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/x509.c, lib/x509/x509_int.h,
	tests/certs-interesting/cert5.der.err: x509: optimize subject
	alternative name access That reads SAN and IAN early on import, significantly reducing the
	running time of functions which iterate over the alternative names
	of a certificate, e.g., gnutls_x509_crt_check_hostname().  Relates #165 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-12  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2017-02-12  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/includes/gnutls/gnutls.h.in: gnutls.h: corrected typo

2017-01-16  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/doc.mk, doc/manpages/Makefile.am: doc:
	removed references to OpenPGP functions and enumerations Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-15  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/gnutls-guile.texi: doc: removed documentation related to
	OpenPGP and guile Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/openpgp.h: openpgp.h: all openpgp
	functionality was marked as deprecated This is to prevent new applications using that functionality.  As
	the OpenPGP certificate for HTTPS (or TLS in general) never got any
	traction, GnuTLS is the only implementation supporting it, and the
	quality of the OpenPGP supporting code is questionable, we deprecate
	that code with the intention to drop it completely when an
	opportunity is given.  Relates #102 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-gtls-app.texi: doc: document the intention of the priority
	string usage [ci skip] This documents the gnutls_set_default_priority() function, and how
	it is intended to be combined with an application that utilizes
	priority strings.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-12  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, m4/hooks.m4: bumped version

2017-02-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .travis.yml: .travis.yml: list all logs on failure Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert_verify_inv_utf8.c, tests/crq_apis.c, tests/crt_apis.c,
	tests/hostname-check-utf8.c, tests/mini-server-name.c,
	tests/set_key_utf8.c, tests/set_x509_key_utf8.c: tests: enable all
	IDNA tests when compiled with libidn2 Keep IDNA2003-only tests on the ifdef HAVE_LIBIDN.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .travis.yml: .travis.yml: updated instructions for travis builds Removed unbound and other minor fixes.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/extras/hex.h: extras/hex.h: do not use strlen as variable name That is, do not utilize a standard C function name as variable name.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11.c: gnutls_pkcs11_obj_list_import_url4: always return an
	initialized pointer When returning success, but no elements,
	gnutls_pkcs11_obj_list_import_url4, could have returned zero number
	of elements with a pointer that was uninitialized.  Ensure that an
	initialized (i.e., null in that case), pointer is always returned.
	Reported by Jeremy Harris.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-02-03  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: use libidn2 on windows builds Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-02-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/pkcs7: Address test suite failure due to timezone
	differences.  Reported by Thorsten Glaser and Andreas Metzler.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/str-idna.c: _idn2_to_unicode_8z8z: do not err on mixed IDNA
	domains That is allow domains of the form 'großes.xn--fa-hia.de'. The
	drawback is that we may not err early on invalid formatted names. We
	however delegate any such decisions to libidn2.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-01-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: Updated
	auto-generated files Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str-idna.c: str-idna: improved error handling In addition to detecting input with invalid characters in
	_idn2_to_unicode_8z8z(), we also add support for case insensitive
	punycode header.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-25  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/str-idna.c: str-idna: cleanups in IDNA handling Ensure safe operation even with broken libidn2, and make sure that
	we properly allocate memory to caller, even on complex library
	configuration.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/Makefile.am, lib/str-idna.c, lib/str-unicode.c: Move IDNA
	functionality to str-idna.c from str-unicode.c Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/str-idna.c: tests: use the exported API for IDNA testing In addition group together the tests which require libidn2 >= 0.14.
	This allows the tests to succeed.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/socket.c: tools: depend on gnutls_idna_map() instead of using
	directly libidn/libidn2 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/includes/gnutls/gnutls.h.in, lib/libgnutls.map,
	lib/str-unicode.c, lib/str.h, lib/x509/output.c: Exported
	gnutls_idna_map() and gnutls_idna_reverse_map() Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: added run with IDNA2003 Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/str-idna.c: tests: simplified str-idna This separates the directions that are tested (utf-8 -> punycode and
	vice versa).  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-24  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac: configure: added flag to force IDNA2003 That allows to compile with libidn even if libidn2 is present, and
	can be used to check IDNA2003 support.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-21  Tim Rühsen <tim.ruehsen@gmx.de>

	* INSTALL.md, README.md, configure.ac, lib/Makefile.am,
	lib/str-unicode.c, lib/str.h, src/socket.c, tests/str-idna.c: Add
	support for libidn2 (IDNA 2008 + TR46) Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>

2017-01-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/heartbeat.c: heartbeat extension: doc update Document how to calculate the total TLS data transmitted.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-20  Alon Bar-Lev <alon.barlev@gmail.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: add Fedora/x86_64/no-tools Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-20  Alon Bar-Lev <alon.barlev@gmail.com>

	* .gitignore, configure.ac, gl/m4/valgrind-tests.m4,
	gl/override/m4/valgrind-tests.m4.diff: valgrind: support separate
	builddir for suppressions.valgrind Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-20  Alon Bar-Lev <alon.barlev@gmail.com>

	* configure.ac: configure: remove void statement Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-20  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/key-tests/illegal-rsa: tests: skip tests that requires tools
	if tools are disabled building with --disable-tools should not cause test failure.  Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-25  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/pkcs7-crypt.c: pkcs7 decryption: addressed memory leak in
	PBES1-DES-CBC-MD5 handling Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-25  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac: configure: do not disable valgrind tests unless
	explicitly specified ... or unless we are in release build.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-25  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/suite/testpkcs11.sh: tests: verify that a written
	certificate will inherit its ID from privkey That is, whether p11tool will do the right thing and figure the
	proper ID to use for a certificate object, if the public key is
	available.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/pkcs11.c: p11tool: re-use ID from corresponding objects when
	writing certificates That is when writing a certificate which has a corresponding public
	key, or private key in the token, ensure that we use the same ID for
	the objects. That eases the work of someone writing objects to
	certificates, and does not require him to manually detect the object
	IDs.  Resolves #160 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-22  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-gtls-app.texi, lib/dh.c: doc: improved documentation on DH
	parameters [ci skip]

2017-01-05  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/cert-tests/openpgp-certs, tests/danetool.sh,
	tests/fastopen.sh, tests/key-tests/dsa,
	tests/ocsp-tests/ocsp-must-staple-connection,
	tests/ocsp-tests/ocsp-tls-connection, tests/scripts/common.sh,
	tests/starttls.sh, tests/suite/eagain.sh,
	tests/suite/testcompat-main-openssl,
	tests/suite/testcompat-main-polarssl, tests/suite/testdane.sh,
	tests/suite/testpkcs11.sh, tests/suite/testrng.sh,
	tests/suite/testsrn.sh: tests: remove bash usage Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-05  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/suite/chain.sh: tests: suite: chain: support separate
	builddir Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-05  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/cert-tests/crq, tests/cert-tests/krb5-test,
	tests/cert-tests/md5-test, tests/cert-tests/name-constraints,
	tests/cert-tests/othername-test, tests/cert-tests/pkcs1-pad,
	tests/cert-tests/pkcs7, tests/cert-tests/pkcs7-cat,
	tests/cert-tests/pkcs7-constraints,
	tests/cert-tests/pkcs7-constraints2, tests/cert-tests/sha3-test,
	tests/cert-tests/template-exts-test,
	tests/cert-tests/template-test, tests/cert-tests/tlsfeature-test,
	tests/ocsp-tests/ocsp-must-staple-connection,
	tests/ocsp-tests/ocsp-test, tests/ocsp-tests/ocsp-tls-connection,
	tests/rsa-md5-collision/rsa-md5-collision.sh,
	tests/suite/testcompat-main-openssl,
	tests/suite/testcompat-main-polarssl: tests: skip tests that
	requires tools if tools are disabled building with --disable-tools should not cause test failure.  Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2016-12-31  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/cert-tests/aki, tests/cert-tests/certtool,
	tests/cert-tests/certtool-long-cn,
	tests/cert-tests/certtool-long-oids, tests/cert-tests/crl,
	tests/cert-tests/email, tests/cert-tests/openpgp-certs,
	tests/cert-tests/openpgp-selfsigs, tests/cert-tests/pathlen,
	tests/cert-tests/pem-decoding, tests/cert-tests/pkcs12,
	tests/cert-tests/pkcs12-utf8, tests/cert-tests/pkcs7-broken-sigs,
	tests/cert-tests/privkey-import, tests/cert-tests/provable-dh,
	tests/cert-tests/provable-dh-default,
	tests/cert-tests/provable-privkey,
	tests/cert-tests/provable-privkey-dsa2048,
	tests/cert-tests/provable-privkey-gen-default,
	tests/cert-tests/provable-privkey-rsa2048,
	tests/cert-tests/sha2-dsa-test, tests/cert-tests/sha2-test,
	tests/cert-tests/userid, tests/fastopen.sh, tests/key-tests/dsa,
	tests/key-tests/ecdsa, tests/key-tests/key-id,
	tests/key-tests/key-invalid, tests/key-tests/pkcs8,
	tests/key-tests/pkcs8-decode, tests/key-tests/pkcs8-invalid,
	tests/rfc2253-escape-test, tests/starttls.sh, tests/suite/chain.sh,
	tests/suite/crl-test, tests/suite/eagain.sh,
	tests/suite/invalid-cert.sh, tests/suite/pkcs7-cat,
	tests/suite/testdane.sh, tests/suite/testpkcs11.sh,
	tests/suite/testrandom.sh, tests/suite/testsrn.sh: tests: skip tests
	that requires tools if tools are disabled building with --disable-tools should not cause test failure.  Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-03  Alon Bar-Lev <alon.barlev@gmail.com>

	* tests/cert-tests/pkcs12, tests/cert-tests/pkcs12-utf8: tests:
	cert-tests: pkcs12 drop builddir usage sync with other tests Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-01-15  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/accelerated/x86/x86-common.c: Disable AVX support when it is
	not supported by the CPU This mostly affects virtual systems. Reported by Frank Chen.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

2017-01-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/cha-cert-auth.texi, doc/cha-functions.texi,
	doc/cha-gtls-app.texi, doc/cha-tokens.texi, doc/gnutls-pgp.eps,
	doc/latex/Makefile.am: doc: removed documentation related to OpenPGP Also added section explaining why OpenPGP is being deprecated.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/read-packet.c: opencdk: improved error code checking
	in the stream reading functions This ammends 49be4f7b82eba2363bb8d4090950dad976a77a3a Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update [ci skip]

2017-01-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/key-tests/Makefile.am: tests: added missing file

2017-01-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, m4/hooks.m4: bumped version

2017-01-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update [ci skip]

2017-01-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-01-03  Alon Bar-Lev <alon.barlev@gmail.com>

	* .gitignore: gitignore: update Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-03  Alon Bar-Lev <alon.barlev@gmail.com>

	* .gitignore: gitignore: sort() Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/read-packet.c: opencdk: added error checking in the
	stream reading functions This addresses an out of memory error. Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=337 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/data/openpgp-invalid4.pub,
	tests/cert-tests/openpgp-cert-parser: tests: added test case with
	invalid openpgp cert This triggers an out of memory error. Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=337 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/pubkey.c: opencdk: cdk_pk_get_keyid: fix stack
	overflow Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=340 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/openpgp-cert-parser: tests: added test case with
	invalid openpgp cert This triggers a memory error. Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=340 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/openpgp-cert-parser: tests: added test case with
	invalid openpgp cert This triggers a memory error. Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=346 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/opencdk/read-packet.c: opencdk: read_attribute: added more
	precise checks when reading stream That addresses heap read overflows found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=338   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=346 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/openpgp-cert-parser: tests: added test case with
	invalid openpgp cert This triggers a memory error. Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=338 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/openpgp-cert-parser: tests: openpgp-cert-parser:
	simplified

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs12_encr.c: _gnutls_pkcs12_string_to_key: avoid
	division by zero when salt_size = 0 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/x509_ext.c: gnutls_x509_ext_import_policies: fixed memory
	leak on error path Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: added test case with invalid X.509 cert This triggers a memory leak. Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=294 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: added test case with invalid X.509 cert Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=300 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509 output: fixed memory leak in AIA extension
	printing Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/auth/dh_common.c: proc_server_kx: eliminated leak on error
	path Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=272 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am: tests: do not run key-tests under
	leak sanitizer The reason is that we cannot distinguish between a memory leak on
	application failure (which is followed by exit- thus should be
	ignored) and an address sanitizer issue (which should never be
	ignored).  As such we disable leak detection with asan and rely on
	valgrind.  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/illegal-rsa: tests: illegal-rsa: don't hide stderr

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/common.c: _gnutls_x509_get_signature: fix memory leak on
	error path

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: added test case with invalid X.509
	certificate This certificate causes a memory leak while printing.  Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=280 Relates #156

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509: address leak in print_altname - cert
	printing

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: added certificate to reproduce memory
	leak Found by oss-fuzz project:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=299 Relates #156

2017-01-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c: status_request: eliminated leak on error
	path Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=269 Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2016-12-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitmodules: submodules: use the github mirror of openssl

2017-01-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/auth/rsa.c: auth rsa: eliminated memory leak on pkcs-1
	formatting attack path Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update [ci skip]

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* gl/m4/valgrind-tests.m4, gl/override/m4/valgrind-tests.m4.diff: 
	valgrind: use different exit code to signify error This allows the test suite to differentiate between valgrind and
	expected errors from tools.

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am: tests: cert-tests: force asan to
	return an error code other than one on failure

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey_pkcs8.c: gnutls_pkcs8_info: addressed memory leak
	on error path

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: pkcs8_info_int: fix memory leak

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/mpi.c: wrap_nettle_mpi_modm: bail on a modulus that is
	zero Relates #156

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am, tests/key-tests/key-invalid: tests:
	added test for invalid private keys Also force asan to return an error code other than one (the normally
	expected for invalid keys).

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am, tests/key-tests/pkcs8-invalid: tests:
	added test case with invalid PKCS#8 data Issue found using oss-fuzz:   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=363 Relates #156

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: pkcs7 decrypt: require a valid IV size on
	all ciphers That is, do not accept the IV size present in the structure as valid
	without checking.  Relates #156

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: don't print PKCS#8 information when
	outputting DER data

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey_pkcs8.c: pkcs8: pkcs8_key_info() will correctly
	detect non-encrypted files

2017-01-01  Alex Gaynor <alex.gaynor@gmail.com>

	* lib/opencdk/read-packet.c, tests/cert-tests/data/subpkt-leak.pub,
	tests/cert-tests/openpgp-cert-parser: Corrected a leak in OpenPGP
	sub-packet parsing.  Signed-off-by: Alex Gaynor <alex.gaynor@gmail.com>

2016-12-30  Alex Gaynor <alex.gaynor@gmail.com>

	* lib/opencdk/read-packet.c, tests/cert-tests/openpgp-cert-parser: 
	Attempt to fix a leak in OpenPGP cert parsing.

2016-12-26  Alex Gaynor <alex.gaynor@gmail.com>

	* lib/opencdk/read-packet.c, tests/cert-tests/Makefile.am,
	tests/cert-tests/data/truncated.pub,
	tests/cert-tests/openpgp-cert-parser: Do not infinite loop if an EOF
	occurs while skipping a PGP packet Signed-off-by: Alex Gaynor <alex.gaynor@gmail.com>

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/gnutls.texi: doc: fixed copyright date in gnutls.texi

2017-01-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/random.c: gnutls_rnd: document the available values of level
	[ci skip] This enables using the function by only checking the man page.

2016-12-31  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testcompat-main-openssl: tests: enable all the
	ciphersuite in openssl cli for DSS checks

2016-12-31  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testcompat-main-openssl: tests: don't check against
	3DES if disabled in openssl

2016-12-31  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testcompat-main-openssl: tests: do not pass the
	-dhparams to openssl 1.1.0; it doesn't work

2016-12-31  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/params.dh: tests: simplified DH params format Also switch to RFC7919 DH params.

2016-12-31  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testcompat-common,
	tests/suite/testcompat-main-openssl,
	tests/suite/testcompat-main-polarssl: tests: added common variable
	for DH parameters

2016-12-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testcompat-common: tests: fixed paths in compat tests

2016-12-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testcompat-main-openssl,
	tests/suite/testcompat-main-polarssl: tests: better termination
	checking in compat tests This ensures that the exit code of all spawned processes is checked.

2016-12-31  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/certtool.c: certtool: improved error reporting on file error

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: changed buildroot to fedora25

2016-12-30  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/certtool.c: certtool: properly report unencrypted PKCS#8 keys
	in --p8-info

2016-12-21  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-12-21  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, lib/priority.c: configure: introduced
	--with-priority-string option This allows specifying the priority string to be used with
	gnutls_set_default_priority() on configure time.

2016-12-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-12-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/auto-verify.c, lib/gnutls_int.h, lib/priority.c: priorities:
	reset the profile flags when appending new flags That is, to avoid causing issues to applications calling
	gnutls_*priority_set() multiple times with different parameters. In
	that case if multiple profiles are used the outcome could be
	undefined. Now, the last call will prevail.

2016-12-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/auto-verify.c: gnutls_session_set_verify_cert: doc update

2016-12-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/priority.c: Revert "priorities: set the additional verify
	flags instead of appending them" This reverts commit aaf49747f981f6c17cdc9ea7495a8948a5015ae2.

2016-12-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* : commit 6c22fa8349384267e7c2ab99edea8bd43420e823 Author: Nikos
	Mavrogiannopoulos <nmav@gnutls.org> Date:   Mon Dec 19 11:09:41 2016
	+0000

2016-12-17  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* : commit 82f132aa61edf1e663b005f8305b8e82dd028fab Author: Nikos
	Mavrogiannopoulos <nmav@gnutls.org> Date:   Fri Dec 16 16:19:29 2016
	+0000

2016-12-15  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* : commit 3debe362faa62e5b381b880e3ba23aee07c85f6e Author:
	Alexander Kanavin <alex.kanavin@gmail.com> Date:   Wed Dec 14
	17:42:45 2016 +0200

2016-12-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: _gnutls_pkcs_raw_decrypt_data: merge all
	errors during decryption to GNUTLS_E_DECRYPTION_FAILED This makes the function's return values simpler to handle.

2016-12-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS, configure.ac: bumped version and doc update [ci skip]

2016-12-14  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* configure.ac: configure.ac: remove autogen'erated files only if
	necessary Currently autogen'erated files will be removed on each call to
	configure. However this would break the build if one of previous
	make invocations have created corresponding stamp files.  Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-12-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/pkcs8-key-decode-encrypted.c,
	tests/pkcs8-key-decode.c: tests: added test for PKCS#8 encrypted key
	decoding This also verifies that the return value when attempting to decrypt
	without a password is GNUTLS_E_DECRYPTION_FAILED.

2016-12-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey_pkcs8.c: pkcs8: ensure that the correct error
	code is returned on decryption failure

2016-12-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-gtls-app.texi, doc/cha-tokens.texi: doc update [ci skip]

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-args.def: doc: updated to documentation of certtool
	[ci skip] This corrects options which incorrectly mentioned they support URLs.

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/x509.h, lib/x509/verify-high.c,
	lib/x509/verify-high2.c: x509: better documented
	gnutls_trust_list_flags_t

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/suite/Makefile.am: tests: disable ASAN leak checks on suite
	tests These detect memory leaks in the tools in src/ which are not
	critical nor there is serious reason to address.

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am: tests: disable ASAN leak checks on
	certificate tests These detect memory leaks in the tools in src/ which are not
	critical nor there is serious reason to address.

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/long-session-id.c: tests: enhanced long-session-id test This ensures that no leaks exist during exit (to avoid asan
	failures), and that we test for the specific error code that
	gnutls_handshake() is expected to return.

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/handshake.c: handshake: return GNUTLS_E_ILLEGAL_PARAMETER on
	invalid ID size This is a more sensible error code to return on invalid packet.

2016-12-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/crq-basic.c: tests: eliminate compilation warning in
	crq-basic [ci skip]

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: do not enable IDN support in
	minimal build

2016-12-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure.ac: use AC_CONFIG_LINKS to copy
	autogenerated files

2016-12-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-args.c.bak, src/certtool-args.h.bak,
	src/cli-args.c.bak, src/cli-args.h.bak, src/cli-debug-args.c.bak,
	src/cli-debug-args.h.bak, src/danetool-args.c.bak,
	src/danetool-args.h.bak, src/ocsptool-args.c.bak,
	src/ocsptool-args.h.bak, src/p11tool-args.c.bak,
	src/p11tool-args.h.bak, src/psktool-args.c.bak,
	src/psktool-args.h.bak, src/serv-args.c.bak, src/serv-args.h.bak,
	src/srptool-args.c.bak, src/srptool-args.h.bak,
	src/systemkey-args.c.bak, src/systemkey-args.h.bak,
	src/tpmtool-args.c.bak, src/tpmtool-args.h.bak: Added autogen
	pre-generated files into repository This allows building gnutls from git in systems without using
	autogen.

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml, configure.ac: configure: added option to enable
	maintainer mode That makes normal builds, not regenerate Makefiles or configure,
	allowing for faster CI builds on second stage.

2016-11-15  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml, README.md, devel/README.ci-runners: 
	.gitlab-ci.yml: split the CI run into stages In addition avoid re-generating images for operating systems on
	every build and use pre-built images, which are generated in the
	gnutls-build-images sub-project. That allows for faster and more
	reliable (independent of network) CI runs.

2016-12-01  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: use local libopts on x86 This works around autogen failures on x86-64 centos7 CI hosts.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-gtls-app.texi: doc: updated documentation on
	multithreading [ci skip] Resolves #154

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-gtls-app.texi: doc: list gnutls_init_flags_t [ci skip] Suggested by Tyler Burns.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/crq_apis.c, tests/crt_apis.c: tests: make conditional (to
	HAVE_LIBIDN) any IDN related checks This allows the test suite to successfully complete even when
	compiled without libidn.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str.h: str: do not call gnutls_assert in inline function This allows the build to succeed when compiled without libidn.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/rsa-md5-collision/rsa-md5-collision.sh: tests: disable leak
	checks in rsa-md5-collision.sh

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/hostname-check-utf8.c,
	tests/hostname-check.c: tests: split and enhanced UTF-8 name checks
	from hostname-check That is, added checks to ensure that non-ASCII DNS names in
	certificates fail, and that properly encoded IDNA2003 names,
	succeed.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-common.h,
	tests/cert_verify_inv_utf8.c, tests/utils.h: tests: added check with
	failed verification on invalid UTF-8 That is, check whether raw UTF-8 in the certificate will fail
	verification. Raw UTF-8 is prohibited by IETF PKIX (RFC5280) on a
	certificate.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-common.h: tests: updated cert with UTF8 names to
	contain proper IDNA2003 encoded names

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/x509.h, lib/x509/email-verify.c: 
	gnutls_x509_crt_check_email type changed to unsigned This reflects the documented returned value type (bool), and allows
	the compiler to warn on accidental checks for negative value.

2016-12-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/email-verify.c, lib/x509/hostname-verify.c: x509: do not
	attempt to ACE encode values stored in certificates The email and hostname values are required to be in ASCII form by
	PKIX.  We instead ignore these names, if their values are outside
	the ASCII printable character set.

2016-12-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: removed libintl references They are no longer shipped in the build systems.

2016-12-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/key-tests/Makefile.am: tests: added missing test in dist

2016-12-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/starttls.sh: tests: corrected typos in starttls.sh This allows to detect chat in most systems.

2016-12-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, configure.ac, m4/hooks.m4: bumped version

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am,
	tests/rsa-md5-collision/colliding-chain-md5-1.pem,
	tests/rsa-md5-collision/colliding-chain-md5-2.pem,
	tests/rsa-md5-collision/rsa-md5-collision.sh: tests: reduced the
	intermediate steps in rsa-md5-collision

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure: break after finding the first libtspi It may happen that multiple versions are available on a system, and
	by using the first one we ensure, that we are using the 64-bit
	version on 64-bit system, instead of falling back to the 32-bit.

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/keygen.c: tests: added operational -sign/verify- tests in
	keygen app This will check that a generated key is immediately usable for
	operations.

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey.c: gnutls_x509_privkey_cpy: use
	_gnutls_pk_params_copy This ensures that all fields of parameters are copied. Inspired by
	patch of Dmitry Eremin-Solenikov.

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/keygen.c: tests: enhanced keygen to include check of
	gnutls_x509_privkey_cpy

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/crl_apis.c: tests: added tests for CRL
	generation APIs

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crl_write.c: x509 crl: document the nextUpdate field
	limitation

2016-12-06  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* src/certtool.c, tests/cert-tests/data/arb-extensions.csr,
	tests/cert-tests/data/template-tlsfeature.csr: Don't trash DER CRQ
	output with text data Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-12-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crl_write.c: x509 crl: Allow generation of CRLs not to
	specify a nextUpdate

2016-12-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update [ci skip]

2016-12-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-overhead.c: tests: updated overhead calculation for new
	code

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/dtls.c: DTLS: more precise overhead calculation That takes into account space available due to padding, and allows
	it to be included for use in the gnutls_get_data_mtu().  Resolves #140

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/dtls1-2-mtu-check.c: tests: added check
	for MTU calculation on DTLS 1.2

2016-12-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/Makefile.am: src: clean all stamp files on 'make clean'

2016-12-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure: search 64-bit paths for libtspi before
	32-bit paths That is, because 64-bit systems may have both 64-bit and 32-bit
	paths while 32-bit systems only the latter.

2016-12-03  James Bottomley <James.Bottomley@HansenPartnership.com>

	* lib/tpm.c: tpm: fix handling of keys requiring authorization There are several problems with the key handling in the tpm code.  The first, and most serious, is that we should make sure we
	understand the authorization requirements of a key *before* using
	it.  The reason for this is that the TPM has a dictionary attack
	defence and is programmed to lock up after a certain number of
	authorization failures (which can be very small).  If we try first
	without authorization, we may lock up the TPM.  The fix for this is
	to check whether authorization is required and supply it before
	using the key.  Secondly, if the key does require authorization but no password is
	supplied we should return immediately, since we know the TPM will
	give us an authorization error anyway.  Thirdly, we should unconditionally read the policy of the key rather
	than checking if a policy exists: Policies are tied to key objects,
	so if there is an old policy in s->tpm_key_policy, but we're
	creating a new key, the key it belonged to will be closed, meaning
	the policy will be invalid.  Fix this by always setting the policy
	each time we get a new key object.  Signed-off-by: James Bottomley
	<James.Bottomley@HansenPartnership.com>

2016-12-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/abstract_int.h, lib/privkey.c, lib/tpm.c: In
	import_tpm_key_cb() fix the wrong password loop When calling import_tpm_key() once it initializes the key, but a
	second call fails due to the key being already initialized. Ensure
	that failure of import_tpm_key() leaves the key on a clear state.  Reported by James Bottomley <James.Bottomley@HansenPartnership.com>.

2016-12-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/gl/Makefile.am, src/gl/accept.c, src/gl/alloca.in.h,
	src/gl/arpa_inet.in.h, src/gl/asnprintf.c, src/gl/basename-lgpl.c,
	src/gl/bind.c, src/gl/c-ctype.c, src/gl/c-ctype.h, src/gl/close.c,
	src/gl/connect.c, src/gl/dirname-lgpl.c, src/gl/dirname.h,
	src/gl/dosname.h, src/gl/dup2.c, src/gl/errno.in.h, src/gl/error.c,
	src/gl/error.h, src/gl/exitfail.c, src/gl/exitfail.h,
	src/gl/fd-hook.c, src/gl/fd-hook.h, src/gl/flexmember.h,
	src/gl/float+.h, src/gl/float.c, src/gl/float.in.h, src/gl/fseek.c,
	src/gl/fseeko.c, src/gl/fstat.c, src/gl/ftell.c, src/gl/ftello.c,
	src/gl/gai_strerror.c, src/gl/getaddrinfo.c, src/gl/getdelim.c,
	src/gl/getline.c, src/gl/getpass.c, src/gl/getpass.h,
	src/gl/getpeername.c, src/gl/getprogname.c, src/gl/getprogname.h,
	src/gl/gettext.h, src/gl/gettime.c, src/gl/gettimeofday.c,
	src/gl/inet_ntop.c, src/gl/inet_pton.c, src/gl/intprops.h,
	src/gl/itold.c, src/gl/limits.in.h, src/gl/listen.c,
	src/gl/lseek.c, src/gl/m4/00gnulib.m4,
	src/gl/m4/absolute-header.m4, src/gl/m4/alloca.m4,
	src/gl/m4/arpa_inet_h.m4, src/gl/m4/bison.m4,
	src/gl/m4/clock_time.m4, src/gl/m4/close.m4, src/gl/m4/dirname.m4,
	src/gl/m4/double-slash-root.m4, src/gl/m4/dup2.m4,
	src/gl/m4/eealloc.m4, src/gl/m4/environ.m4, src/gl/m4/errno_h.m4,
	src/gl/m4/error.m4, src/gl/m4/exponentd.m4,
	src/gl/m4/extensions.m4, src/gl/m4/extern-inline.m4,
	src/gl/m4/flexmember.m4, src/gl/m4/float_h.m4, src/gl/m4/fseek.m4,
	src/gl/m4/fseeko.m4, src/gl/m4/fstat.m4, src/gl/m4/ftell.m4,
	src/gl/m4/ftello.m4, src/gl/m4/getaddrinfo.m4,
	src/gl/m4/getdelim.m4, src/gl/m4/getline.m4, src/gl/m4/getpass.m4,
	src/gl/m4/getprogname.m4, src/gl/m4/gettime.m4,
	src/gl/m4/gettimeofday.m4, src/gl/m4/gnulib-cache.m4,
	src/gl/m4/gnulib-common.m4, src/gl/m4/gnulib-comp.m4,
	src/gl/m4/gnulib-tool.m4, src/gl/m4/hostent.m4,
	src/gl/m4/include_next.m4, src/gl/m4/inet_ntop.m4,
	src/gl/m4/inet_pton.m4, src/gl/m4/intmax_t.m4,
	src/gl/m4/inttypes_h.m4, src/gl/m4/largefile.m4,
	src/gl/m4/limits-h.m4, src/gl/m4/longlong.m4, src/gl/m4/lseek.m4,
	src/gl/m4/malloc.m4, src/gl/m4/malloca.m4, src/gl/m4/math_h.m4,
	src/gl/m4/memchr.m4, src/gl/m4/minmax.m4, src/gl/m4/mktime.m4,
	src/gl/m4/mmap-anon.m4, src/gl/m4/msvc-inval.m4,
	src/gl/m4/msvc-nothrow.m4, src/gl/m4/multiarch.m4,
	src/gl/m4/netdb_h.m4, src/gl/m4/netinet_in_h.m4,
	src/gl/m4/off_t.m4, src/gl/m4/parse-datetime.m4,
	src/gl/m4/printf.m4, src/gl/m4/read-file.m4, src/gl/m4/realloc.m4,
	src/gl/m4/select.m4, src/gl/m4/servent.m4, src/gl/m4/setenv.m4,
	src/gl/m4/signal_h.m4, src/gl/m4/size_max.m4,
	src/gl/m4/snprintf.m4, src/gl/m4/socketlib.m4,
	src/gl/m4/sockets.m4, src/gl/m4/socklen.m4, src/gl/m4/sockpfaf.m4,
	src/gl/m4/ssize_t.m4, src/gl/m4/stdalign.m4, src/gl/m4/stdbool.m4,
	src/gl/m4/stddef_h.m4, src/gl/m4/stdint.m4, src/gl/m4/stdint_h.m4,
	src/gl/m4/stdio_h.m4, src/gl/m4/stdlib_h.m4, src/gl/m4/strdup.m4,
	src/gl/m4/strerror.m4, src/gl/m4/strftime.m4,
	src/gl/m4/string_h.m4, src/gl/m4/sys_select_h.m4,
	src/gl/m4/sys_socket_h.m4, src/gl/m4/sys_stat_h.m4,
	src/gl/m4/sys_time_h.m4, src/gl/m4/sys_types_h.m4,
	src/gl/m4/sys_uio_h.m4, src/gl/m4/time_h.m4, src/gl/m4/time_r.m4,
	src/gl/m4/time_rz.m4, src/gl/m4/timegm.m4, src/gl/m4/timespec.m4,
	src/gl/m4/tm_gmtoff.m4, src/gl/m4/unistd_h.m4,
	src/gl/m4/vasnprintf.m4, src/gl/m4/warn-on-use.m4,
	src/gl/m4/wchar_h.m4, src/gl/m4/wchar_t.m4, src/gl/m4/wint_t.m4,
	src/gl/m4/xalloc.m4, src/gl/m4/xsize.m4, src/gl/malloc.c,
	src/gl/malloca.c, src/gl/malloca.h, src/gl/memchr.c,
	src/gl/minmax.h, src/gl/mktime-internal.h, src/gl/mktime.c,
	src/gl/msvc-inval.c, src/gl/msvc-inval.h, src/gl/msvc-nothrow.c,
	src/gl/msvc-nothrow.h, src/gl/netdb.in.h, src/gl/netinet_in.in.h,
	src/gl/parse-datetime.h, src/gl/parse-datetime.y,
	src/gl/printf-args.c, src/gl/printf-args.h, src/gl/printf-parse.c,
	src/gl/printf-parse.h, src/gl/progname.c, src/gl/progname.h,
	src/gl/read-file.c, src/gl/read-file.h, src/gl/realloc.c,
	src/gl/recv.c, src/gl/recvfrom.c, src/gl/select.c, src/gl/send.c,
	src/gl/sendto.c, src/gl/setenv.c, src/gl/setsockopt.c,
	src/gl/shutdown.c, src/gl/signal.in.h, src/gl/size_max.h,
	src/gl/snprintf.c, src/gl/socket.c, src/gl/sockets.c,
	src/gl/sockets.h, src/gl/stdalign.in.h, src/gl/stdbool.in.h,
	src/gl/stddef.in.h, src/gl/stdint.in.h, src/gl/stdio-impl.h,
	src/gl/stdio.in.h, src/gl/stdlib.in.h, src/gl/strdup.c,
	src/gl/strerror-override.c, src/gl/strerror-override.h,
	src/gl/strerror.c, src/gl/strftime.c, src/gl/strftime.h,
	src/gl/string.in.h, src/gl/stripslash.c, src/gl/sys_select.in.h,
	src/gl/sys_socket.c, src/gl/sys_socket.in.h, src/gl/sys_stat.in.h,
	src/gl/sys_time.in.h, src/gl/sys_types.in.h, src/gl/sys_uio.in.h,
	src/gl/time-internal.h, src/gl/time.in.h, src/gl/time_r.c,
	src/gl/time_rz.c, src/gl/timegm.c, src/gl/timespec.h,
	src/gl/unistd.c, src/gl/unistd.in.h, src/gl/unsetenv.c,
	src/gl/vasnprintf.c, src/gl/vasnprintf.h, src/gl/verify.h,
	src/gl/w32sock.h, src/gl/wchar.in.h, src/gl/xalloc-die.c,
	src/gl/xalloc-oversized.h, src/gl/xalloc.h, src/gl/xmalloc.c,
	src/gl/xsize.h: src gl: updated

2016-12-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* GNUmakefile, build-aux/gendocs.sh, build-aux/pmccabe2html,
	build-aux/snippet/arg-nonnull.h, build-aux/snippet/c++defs.h,
	build-aux/snippet/warn-on-use.h, build-aux/useless-if-before-free,
	build-aux/vc-list-files, doc/gendocs_template, gl/Makefile.am,
	gl/alloca.in.h, gl/getdelim.c, gl/iconv_open-aix.h,
	gl/iconv_open-hpux.h, gl/iconv_open-irix.h, gl/iconv_open-osf.h,
	gl/iconv_open-solaris.h, gl/intprops.h, gl/limits.in.h,
	gl/m4/extensions.m4, gl/m4/gnulib-cache.m4, gl/m4/gnulib-comp.m4,
	gl/m4/iconv.m4, gl/m4/limits-h.m4, gl/m4/manywarnings.m4,
	gl/m4/printf.m4, gl/m4/secure_getenv.m4, gl/m4/stdbool.m4,
	gl/m4/stdint.m4, gl/m4/stdio_h.m4, gl/m4/stdlib_h.m4,
	gl/m4/sys_types_h.m4, gl/m4/wchar_h.m4, gl/secure_getenv.c,
	gl/stdint.in.h, gl/stdlib.in.h, gl/string.in.h, gl/strverscmp.c,
	gl/sys_socket.in.h, gl/sys_time.in.h, gl/tests/Makefile.am,
	gl/tests/init.sh, gl/tests/test-iconv.c, gl/tests/test-init.sh,
	gl/tests/test-intprops.c, gl/tests/test-limits-h.c,
	gl/tests/test-stdint.c, gl/tests/test-strverscmp.c,
	gl/vasnprintf.c, gl/verify.h, gl/wchar.in.h, lib/Makefile.am,
	lib/gnutls.pc.in, maint.mk: gl: removed iconv module It is no longer used by the library.

2016-12-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac: configure.ac: detect trousers library on debian

2016-12-03  Andreas Metzler <ametzler@bebt.de>

	* configure.ac: Prevent unwanted linkage to -lhogweed Specify action-if-found for AC_CHECK_LIB when checking for !SuiteB
	curves to keep autoconf from adding -lhogweed to LIBS. This caused
	linkage of e.g. openssl wrapper and C++ library to -lhogweed. The
	issue only shows up if --disable-libdane is specified, since the
	dane autoconf test resets LIBS.

2016-12-02  James Bottomley <James.Bottomley@HansenPartnership.com>

	* configure.ac: Fix inability to find libtspi (trousers) on openSUSE For distro reasons, the path on openSUSE is /lib[64]/libtspi.so.1
	which the current code doesn't find.  Fix this by having it search
	all viable system library locations (/lib /lib64 /usr/lib and
	/usr/lib/lib64) Signed-off-by: James Bottomley
	<James.Bottomley@HansenPartnership.com>

2016-12-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509: fixed output of pubkey

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crl_write.c, lib/x509/x509_write.c: doc: document the
	fact that certificates and CRLs are unusable after generation They must be exported and re-imported if intended to be used for
	signing or verification.

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crl_write.c, lib/x509/x509_write.c: doc: no longer list
	SHA1 as a safe choice in X.509 signing

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: prevent-null termination of buffers
	allocated with fread_file() We do not know whether their allocated size allows for that
	additional null, and we do not need the null termination.

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify.c: gnutls_x509_crl_verify: always return zero on
	success Also document that in previous versions a positive number could be
	returned on success. Reported by Adrien Beraud.

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-usage-ecdhe-rsa.c, tests/key-usage-rsa.c: tests:
	corrected space-tab issue

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/tls-sig.c: Improved messages and violation handling in
	signature key usage checks This will now tolerate violations in server certificate, if
	%DEBUG_ALLOW_KEY_USAGE_VIOLATIONS is set.

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/auth/cert.c, lib/cert.c, lib/x509.c, lib/x509.h: Removed
	redundant certificate key usage checks.  There were redundant checks when a certificate was obtained, as well
	as prior to performing operations with certificates/pubkeys.  Kept
	the checks prior to operations.

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/algorithms.h, lib/algorithms/publickey.c, lib/cert.c,
	lib/handshake.c: _gnutls_map_pk_get_pk -> _gnutls_map_kx_get_pk

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/state.c: gnutls_kx_get: allow calling the function during
	handshake Previous this function would return garbage during handshake,
	because parameters were not considered established, however there
	are valid uses of this function during it. For that reason this
	function is modified to return a correct value even during handshake
	(after a hello is being exchanged).

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509.c: _gnutls_check_key_usage: check for invalid key
	exchange algorithm Reported by Dmitry Eremin-Solenikov.

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/key-usage-ecdhe-rsa.c,
	tests/{key-usage.c => key-usage-rsa.c}: tests: added checks on
	signature key usage violations

2016-12-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: added docker tag on mingw builds That ensures that these builds are done on the gitlab.com runners
	which run as privileged containers (and thus have access to mount).

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey.c: privkey: set the key parameters algorithm
	prior to returning success

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/key_decode.c: When decoding a public key ensure that
	algorithm is written in the params struct Reported by Dmitry Eremin-Solenikov.

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk: cfg.mk: disable checks for public submodule updates in CI

2016-11-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: do not require update to
	/proc/sys/fs/binfmt_misc to succeed In some CI systems, it is not possible to write to this filesystem,
	and they already have the wine executable registered. In the case we
	cannot write proceed to running the check and hope for the best.

2016-11-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/rsa-md5-collision/rsa-md5-collision.sh: tests: use datefudge
	in rsa-md5-collision check This makes sure that any failure detected is not because of expired
	certificates, but because of MD5 being disabled.

2016-11-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore, src/Makefile.am: tools: use stamp files to allow
	parallel build of autogen files Autogen seems to output on the creates files gradually, something
	that makes 'make' believe that the command is complete prior to the
	output file being fully populated. The current approach uses stamp
	files to ensure that no incomplete files are used for compilation.

2016-11-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* guile/tests/priorities.scm: guile: do not use +COMP-DEFLATE in
	priorities test This allows the test to work even in the cases where gnutls is
	compiled without zlib support.

2016-11-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml, cfg.mk: moved all syntax check exceptions in
	cfg.mk

2016-11-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: added zlib dependency

2016-11-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: fixed artifacts paths for Debian
	build

2016-11-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-unicode.c: tests: str-unicode: check whether exceptions
	are tolerated on decryption

2016-11-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-unicode.c: tests: added exception and join control
	characters in str-unicode

2016-11-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk, lib/unistring/Makefile.am,
	lib/unistring/m4/gnulib-cache.m4, lib/unistring/m4/gnulib-comp.m4,
	lib/unistring/unictype/pr_join_control.c,
	lib/unistring/unictype/pr_join_control.h: unistring: added
	property-join-control

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk, lib/unistring/Makefile.am,
	lib/unistring/m4/gnulib-cache.m4, lib/unistring/m4/gnulib-comp.m4,
	lib/unistring/unictype/pr_default_ignorable_code_point.c,
	lib/unistring/unictype/pr_default_ignorable_code_point.h,
	lib/unistring/unictype/pr_not_a_character.c,
	lib/unistring/unictype/pr_not_a_character.h: unistring: added
	default_ignorable_code_point and not_a_character tests

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk, lib/unistring/Makefile.am,
	lib/unistring/m4/gnulib-cache.m4, lib/unistring/m4/gnulib-comp.m4,
	lib/unistring/uninorm/compat-decomposition.c,
	lib/unistring/uninorm/decomposition.c,
	lib/unistring/uninorm/nfkc.c, lib/unistring/uninorm/nfkd.c: 
	unistring: added NFKC normalization

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk, lib/unistring/unicase/special-casing-table.h,
	lib/unistring/unictype/categ_C.c, lib/unistring/unictype/categ_C.h,
	lib/unistring/unictype/categ_Cc.c,
	lib/unistring/unictype/categ_Cc.h,
	lib/unistring/unictype/categ_Cf.c,
	lib/unistring/unictype/categ_Cf.h,
	lib/unistring/unictype/categ_Cn.c,
	lib/unistring/unictype/categ_Cn.h,
	lib/unistring/unictype/categ_Co.c,
	lib/unistring/unictype/categ_Co.h,
	lib/unistring/unictype/categ_Cs.c,
	lib/unistring/unictype/categ_Cs.h,
	lib/unistring/unictype/categ_L.c, lib/unistring/unictype/categ_L.h,
	lib/unistring/unictype/categ_LC.c,
	lib/unistring/unictype/categ_LC.h,
	lib/unistring/unictype/categ_Ll.c,
	lib/unistring/unictype/categ_Ll.h,
	lib/unistring/unictype/categ_Lm.c,
	lib/unistring/unictype/categ_Lm.h,
	lib/unistring/unictype/categ_Lo.c,
	lib/unistring/unictype/categ_Lo.h,
	lib/unistring/unictype/categ_Lt.c,
	lib/unistring/unictype/categ_Lt.h,
	lib/unistring/unictype/categ_Lu.c,
	lib/unistring/unictype/categ_Lu.h,
	lib/unistring/unictype/categ_M.c, lib/unistring/unictype/categ_M.h,
	lib/unistring/unictype/categ_Mc.c,
	lib/unistring/unictype/categ_Mc.h,
	lib/unistring/unictype/categ_Me.c,
	lib/unistring/unictype/categ_Me.h,
	lib/unistring/unictype/categ_Mn.c,
	lib/unistring/unictype/categ_Mn.h,
	lib/unistring/unictype/categ_N.c, lib/unistring/unictype/categ_N.h,
	lib/unistring/unictype/categ_Nd.c,
	lib/unistring/unictype/categ_Nd.h,
	lib/unistring/unictype/categ_Nl.c,
	lib/unistring/unictype/categ_Nl.h,
	lib/unistring/unictype/categ_No.c,
	lib/unistring/unictype/categ_No.h,
	lib/unistring/unictype/categ_P.c, lib/unistring/unictype/categ_P.h,
	lib/unistring/unictype/categ_Pc.c,
	lib/unistring/unictype/categ_Pc.h,
	lib/unistring/unictype/categ_Pd.c,
	lib/unistring/unictype/categ_Pd.h,
	lib/unistring/unictype/categ_Pe.c,
	lib/unistring/unictype/categ_Pe.h,
	lib/unistring/unictype/categ_Pf.c,
	lib/unistring/unictype/categ_Pf.h,
	lib/unistring/unictype/categ_Pi.c,
	lib/unistring/unictype/categ_Pi.h,
	lib/unistring/unictype/categ_Po.c,
	lib/unistring/unictype/categ_Po.h,
	lib/unistring/unictype/categ_Ps.c,
	lib/unistring/unictype/categ_Ps.h,
	lib/unistring/unictype/categ_S.c, lib/unistring/unictype/categ_S.h,
	lib/unistring/unictype/categ_Sc.c,
	lib/unistring/unictype/categ_Sc.h,
	lib/unistring/unictype/categ_Sk.c,
	lib/unistring/unictype/categ_Sk.h,
	lib/unistring/unictype/categ_Sm.c,
	lib/unistring/unictype/categ_Sm.h,
	lib/unistring/unictype/categ_So.c,
	lib/unistring/unictype/categ_So.h,
	lib/unistring/unictype/categ_Z.c, lib/unistring/unictype/categ_Z.h,
	lib/unistring/unictype/categ_Zl.c,
	lib/unistring/unictype/categ_Zl.h,
	lib/unistring/unictype/categ_Zp.c,
	lib/unistring/unictype/categ_Zp.h,
	lib/unistring/unictype/categ_and.c,
	lib/unistring/unictype/categ_and_not.c,
	lib/unistring/unictype/categ_byname.c,
	lib/unistring/unictype/categ_byname.gperf,
	lib/unistring/unictype/categ_longname.c,
	lib/unistring/unictype/categ_name.c,
	lib/unistring/unictype/categ_none.c,
	lib/unistring/unictype/categ_of.c,
	lib/unistring/unictype/categ_of.h,
	lib/unistring/unictype/categ_or.c: unistring: included all possible
	categories for simplicity and extensibility

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-unicode.c: tests: enhanced str-unicode with more char
	sets

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in, lib/str-unicode.c: 
	gnutls_utf8_password_normalize: perform more strict check on input
	characters That is, ensure that the input characters are in the valid class of
	characters for the PRECIS FreeformClass.

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-unicode.c: tests: fixed str-unicode tests with control
	characters

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str-unicode.c: gnutls_utf8_password_normalize: avoid use of
	strlen()

2016-11-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am, tests/cert-tests/pkcs12: tests:
	added pkcs12 file with long password

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/Makefile.am, lib/{system/iconv.c => str-iconv.c}: renamed
	system/iconv.c -> str-iconv.c We no longer use the system's functionality for converting between
	charsets (we use libunistring), hence it is no longer suitable for
	the wrappers to stay in system/.

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509: when printing ACE DNSnames ensure the
	actual name is also printed

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/str-idna.c: tests: added unit tests of of
	_gnutls_idna_reverse_map

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/libgnutls.map, lib/str-unicode.c, lib/str.h: introduced
	_gnutls_idna_reverse_map() This function allows mapping ACE formatted domains to UTF-8.

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/common.c, lib/x509/output.c: Combined checks for
	printable characters

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-11-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/crt_apis.c: tests: updated crt_apis to include setting UTF-8
	SAN

2016-11-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/crq_apis.c: tests: updated crq_apis to include setting UTF-8
	SAN

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str-unicode.c: gnutls_idna_map: check for printable data prior
	to mapping

2016-11-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/virt-san.c, lib/x509/x509_ext.c, lib/x509/x509_ext_int.h: 
	gnutls_x509_aia_set: IDNA encode when needed

2016-11-16  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in, lib/str-unicode.c,
	lib/str.h, lib/x509/crq.c, lib/x509/email-verify.c,
	lib/x509/virt-san.c, lib/x509/virt-san.h, lib/x509/x509_dn.c,
	lib/x509/x509_ext.c, lib/x509/x509_write.c: When writing alternative
	names to certificates ensure we write in ACE format

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/openssl-keyid.p7b.out, tests/cert-tests/pkcs7: 
	tests: added pkcs7 verification with struct generated from openssl
	(with keyid)

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/openssl.p7b.out, tests/cert-tests/pkcs7: 
	tests: added pkcs7 verification with struct generated from openssl

2016-11-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/credentials/x509/Makefile.am,
	doc/credentials/x509/cert-ecc-sign.pem: doc: added certificate for
	ECC with any purpose

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in, lib/x509/pkcs7.c: 
	pkcs7: return GNUTLS_E_PK_SIG_VERIFY_FAILED on hash mismatch In addition introduce a new error code to warn about no embedded
	data.

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-output.c: pkcs7: only print signer's issuer DN when
	DN has contents

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7.c: pkcs7: added recursive discovery of structure's
	signer This uses the PKCS#7 certificate list as a pool of certificates to
	generate a certificate chain that leads to our root CAs.

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7.c: pkcs7: on data verification failure log the
	signer

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/pkcs7-cat-ca.pem, tests/cert-tests/pkcs7-cat: 
	tests: added complex verification example using PKCS#7 That uses multiple intermediate certificates from the PKCS#7
	structure.

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify-high.c: doc: updated
	gnutls_x509_trust_list_verify_crt2()

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7.c: pkcs7: pass the verification flags down to
	gnutls_x509_trust_list_verify_crt2, in find_signer() This allows for flags like GNUTLS_VERIFY_DISABLE_TIME_CHECKS to
	apply when verifying PKCS#7 structures.

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7.c: pkcs7: corrected iteration over stored
	certificates This allows to use all possibly stored certificates on chain
	discovery, not only the first.

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7.c: pkcs7: added debug logging on verification
	discovery

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.h: errors.h: added _gnutls_reason_log

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.h: errors.h: added _gnutls_cert_log This log function allows to easily log the name of a certificate.

2016-11-24  Andreas Schneider <asn@samba.org>

	* src/certtool.c: certtool: One if check is enough Signed-off-by: Andreas Schneider <asn@samba.org>

2016-11-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/server_name.c: corrected log message [ci skip]

2016-11-23  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/libgnutls.map, lib/str-unicode.c, lib/str.h, tests/str-idna.c: 
	gnutls_idna_map was prefixed with underscore to avoid clashes with
	exported symbols

2016-11-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore: more files to ignore

2016-11-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str.c, lib/x509/common.c, lib/x509/output.c: avoid the use of
	c_isascii() and use c_isprint() That latter detects correctly the printable characters we are
	interested in.

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/str-idna.c: tests: added unit tests for
	gnutls_idna_map()

2016-11-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/server_name.c, lib/libgnutls.map, lib/str-unicode.c,
	lib/str.h, lib/x509.c, lib/x509/Makefile.am,
	lib/x509/email-verify.c, lib/x509/gnutls-idna.h,
	lib/x509/hostname-verify.c, lib/x509/output.c,
	lib/x509/pkcs7-output.c: IDNA code re-organization That introduces the internal function gnutls_idna_map(), which
	utilizes libidn and libunistring to convert hostnames to IDNA ACE
	form.

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/data/aki-cert.pem,
	tests/cert-tests/data/arb-extensions.csr,
	tests/cert-tests/data/bmpstring.pem,
	tests/cert-tests/data/ca-no-pathlen.pem,
	tests/cert-tests/data/complex-cert.pem,
	tests/cert-tests/data/gost-cert.pem,
	tests/cert-tests/data/long-oids.pem,
	tests/cert-tests/data/multi-value-dn.pem,
	tests/cert-tests/data/name-constraints-ip2.pem,
	tests/cert-tests/data/no-ca-or-pathlen.pem,
	tests/cert-tests/data/template-tlsfeature.csr,
	tests/cert-tests/data/very-long-dn.pem,
	tests/cert-tests/data/xmpp-othername.pem, tests/dn2.c: tests:
	updated outputs to reflect new fingerprint/keyid formats

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/aki, tests/cert-tests/pathlen: tests: made tmp
	files unique

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: Align the printing of a certificate's
	fingerprint with the key ID printing

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c, src/certtool-common.c: Print a key's or
	certificate's key ID with SHA256 in addition to SHA1

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-cfg.c: certtool: address compiler warnings

2016-11-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-bib.texi, doc/cha-gtls-app.texi, doc/latex/gnutls.bib: 
	doc: document the RFC7613 normalization of passwords [ci skip]

2016-11-21  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* cfg.mk, lib/unistring/Makefile.am,
	lib/unistring/array-mergesort.h, lib/unistring/limits.in.h,
	lib/unistring/m4/gnulib-cache.m4, lib/unistring/m4/gnulib-comp.m4,
	lib/unistring/stdbool.in.h, lib/unistring/stdint.in.h,
	lib/unistring/sys_types.in.h, lib/unistring/unictype.in.h,
	lib/unistring/unictype/bitmap.h, lib/unistring/unictype/categ_C.c,
	lib/unistring/unictype/categ_C.h,
	lib/unistring/unictype/categ_Cc.c,
	lib/unistring/unictype/categ_Cc.h,
	lib/unistring/unictype/categ_Cf.c,
	lib/unistring/unictype/categ_Cf.h,
	lib/unistring/unictype/categ_Cn.c,
	lib/unistring/unictype/categ_Cn.h,
	lib/unistring/unictype/categ_Co.c,
	lib/unistring/unictype/categ_Co.h,
	lib/unistring/unictype/categ_Cs.c,
	lib/unistring/unictype/categ_Cs.h,
	lib/unistring/unictype/categ_L.c, lib/unistring/unictype/categ_L.h,
	lib/unistring/unictype/categ_LC.c,
	lib/unistring/unictype/categ_LC.h,
	lib/unistring/unictype/categ_Ll.c,
	lib/unistring/unictype/categ_Ll.h,
	lib/unistring/unictype/categ_Lm.c,
	lib/unistring/unictype/categ_Lm.h,
	lib/unistring/unictype/categ_Lo.c,
	lib/unistring/unictype/categ_Lo.h,
	lib/unistring/unictype/categ_Lt.c,
	lib/unistring/unictype/categ_Lt.h,
	lib/unistring/unictype/categ_Lu.c,
	lib/unistring/unictype/categ_Lu.h,
	lib/unistring/unictype/categ_M.c, lib/unistring/unictype/categ_M.h,
	lib/unistring/unictype/categ_Mc.c,
	lib/unistring/unictype/categ_Mc.h,
	lib/unistring/unictype/categ_Me.c,
	lib/unistring/unictype/categ_Me.h,
	lib/unistring/unictype/categ_Mn.c,
	lib/unistring/unictype/categ_Mn.h,
	lib/unistring/unictype/categ_N.c, lib/unistring/unictype/categ_N.h,
	lib/unistring/unictype/categ_Nd.c,
	lib/unistring/unictype/categ_Nd.h,
	lib/unistring/unictype/categ_Nl.c,
	lib/unistring/unictype/categ_Nl.h,
	lib/unistring/unictype/categ_No.c,
	lib/unistring/unictype/categ_No.h,
	lib/unistring/unictype/categ_P.c, lib/unistring/unictype/categ_P.h,
	lib/unistring/unictype/categ_Pc.c,
	lib/unistring/unictype/categ_Pc.h,
	lib/unistring/unictype/categ_Pd.c,
	lib/unistring/unictype/categ_Pd.h,
	lib/unistring/unictype/categ_Pe.c,
	lib/unistring/unictype/categ_Pe.h,
	lib/unistring/unictype/categ_Pf.c,
	lib/unistring/unictype/categ_Pf.h,
	lib/unistring/unictype/categ_Pi.c,
	lib/unistring/unictype/categ_Pi.h,
	lib/unistring/unictype/categ_Po.c,
	lib/unistring/unictype/categ_Po.h,
	lib/unistring/unictype/categ_Ps.c,
	lib/unistring/unictype/categ_Ps.h,
	lib/unistring/unictype/categ_S.c, lib/unistring/unictype/categ_S.h,
	lib/unistring/unictype/categ_Sc.c,
	lib/unistring/unictype/categ_Sc.h,
	lib/unistring/unictype/categ_Sk.c,
	lib/unistring/unictype/categ_Sk.h,
	lib/unistring/unictype/categ_Sm.c,
	lib/unistring/unictype/categ_Sm.h,
	lib/unistring/unictype/categ_So.c,
	lib/unistring/unictype/categ_So.h,
	lib/unistring/unictype/categ_Z.c, lib/unistring/unictype/categ_Z.h,
	lib/unistring/unictype/categ_Zl.c,
	lib/unistring/unictype/categ_Zl.h,
	lib/unistring/unictype/categ_Zp.c,
	lib/unistring/unictype/categ_Zp.h,
	lib/unistring/unictype/categ_Zs.c,
	lib/unistring/unictype/categ_and.c,
	lib/unistring/unictype/categ_and_not.c,
	lib/unistring/unictype/categ_byname.c,
	lib/unistring/unictype/categ_byname.gperf,
	lib/unistring/unictype/categ_longname.c,
	lib/unistring/unictype/categ_name.c,
	lib/unistring/unictype/categ_none.c,
	lib/unistring/unictype/categ_of.c,
	lib/unistring/unictype/categ_of.h,
	lib/unistring/unictype/categ_or.c,
	lib/unistring/unictype/categ_test.c,
	lib/unistring/unictype/combiningclass.c,
	lib/unistring/uninorm.in.h,
	lib/unistring/uninorm/canonical-decomposition.c,
	lib/unistring/uninorm/composition-table.gperf,
	lib/unistring/uninorm/composition.c,
	lib/unistring/uninorm/decompose-internal.c,
	lib/unistring/uninorm/decompose-internal.h,
	lib/unistring/uninorm/decomposition-table.c,
	lib/unistring/uninorm/decomposition-table.h,
	lib/unistring/uninorm/nfc.c, lib/unistring/uninorm/nfd.c,
	lib/unistring/uninorm/normalize-internal.h,
	lib/unistring/uninorm/u-normalize-internal.h,
	lib/unistring/uninorm/u16-normalize.c,
	lib/unistring/uninorm/u32-normalize.c,
	lib/unistring/uninorm/u8-normalize.c, lib/unistring/unistr.in.h,
	lib/unistring/unistr/u-cpy.h, lib/unistring/unistr/u16-cpy.c,
	lib/unistring/unistr/u16-mbtouc-unsafe-aux.c,
	lib/unistring/unistr/u16-mbtouc-unsafe.c,
	lib/unistring/unistr/u16-mbtoucr.c,
	lib/unistring/unistr/u16-to-u8.c,
	lib/unistring/unistr/u16-uctomb-aux.c,
	lib/unistring/unistr/u16-uctomb.c, lib/unistring/unistr/u32-cpy.c,
	lib/unistring/unistr/u32-mbtouc-unsafe.c,
	lib/unistring/unistr/u32-to-u8.c,
	lib/unistring/unistr/u32-uctomb.c, lib/unistring/unistr/u8-check.c,
	lib/unistring/unistr/u8-cpy.c,
	lib/unistring/unistr/u8-mbtouc-unsafe-aux.c,
	lib/unistring/unistr/u8-mbtouc-unsafe.c,
	lib/unistring/unistr/u8-mbtoucr.c,
	lib/unistring/unistr/u8-to-u16.c, lib/unistring/unistr/u8-to-u32.c,
	lib/unistring/unistr/u8-uctomb-aux.c,
	lib/unistring/unistr/u8-uctomb.c, lib/unistring/unitypes.in.h: 
	unistring: include only the required categories In addition fix the license text of the included library.

2016-11-16  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/server_name.c: server_name: log server name sent

2016-11-16  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/output.c: x509/output: improve log message on embedded
	null

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* build-aux/snippet/unused-parameter.h: build-aux: added
	unused-parameter.h

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: explicitly specify
	--with-included-unistring when needed

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* m4/hooks.m4: hooks.m4: corrected typo

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: ignore syntax-check issues caused
	by included unistring

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore: more files to ignore

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/str-unicode.c, lib/str.h, lib/system/iconv.c,
	tests/conv-utf8.c, tests/str-unicode.c: unconditionally include
	unistring code That simplifies internationalization support, at the cost of
	including a version of libunistring, which is used on systems which
	do not ship it.

2016-11-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am, cfg.mk, configure.ac, lib/Makefile.am,
	lib/unistring/Makefile.am, lib/unistring/array-mergesort.h,
	lib/unistring/limits.in.h, lib/unistring/m4/00gnulib.m4,
	lib/unistring/m4/absolute-header.m4,
	lib/unistring/m4/gnulib-cache.m4,
	lib/unistring/m4/gnulib-common.m4, lib/unistring/m4/gnulib-comp.m4,
	lib/unistring/m4/gnulib-tool.m4, lib/unistring/m4/include_next.m4,
	lib/unistring/m4/inline.m4, lib/unistring/m4/libunistring-base.m4,
	lib/unistring/m4/limits-h.m4, lib/unistring/m4/longlong.m4,
	lib/unistring/m4/multiarch.m4, lib/unistring/m4/off_t.m4,
	lib/unistring/m4/ssize_t.m4, lib/unistring/m4/stdbool.m4,
	lib/unistring/m4/stdint.m4, lib/unistring/m4/sys_types_h.m4,
	lib/unistring/stdbool.in.h, lib/unistring/stdint.in.h,
	lib/unistring/sys_types.in.h, lib/unistring/unictype.in.h,
	lib/unistring/unictype/bitmap.h, lib/unistring/unictype/categ_C.c,
	lib/unistring/unictype/categ_C.h,
	lib/unistring/unictype/categ_Cc.c,
	lib/unistring/unictype/categ_Cc.h,
	lib/unistring/unictype/categ_Cf.c,
	lib/unistring/unictype/categ_Cf.h,
	lib/unistring/unictype/categ_Cn.c,
	lib/unistring/unictype/categ_Cn.h,
	lib/unistring/unictype/categ_Co.c,
	lib/unistring/unictype/categ_Co.h,
	lib/unistring/unictype/categ_Cs.c,
	lib/unistring/unictype/categ_Cs.h,
	lib/unistring/unictype/categ_L.c, lib/unistring/unictype/categ_L.h,
	lib/unistring/unictype/categ_LC.c,
	lib/unistring/unictype/categ_LC.h,
	lib/unistring/unictype/categ_Ll.c,
	lib/unistring/unictype/categ_Ll.h,
	lib/unistring/unictype/categ_Lm.c,
	lib/unistring/unictype/categ_Lm.h,
	lib/unistring/unictype/categ_Lo.c,
	lib/unistring/unictype/categ_Lo.h,
	lib/unistring/unictype/categ_Lt.c,
	lib/unistring/unictype/categ_Lt.h,
	lib/unistring/unictype/categ_Lu.c,
	lib/unistring/unictype/categ_Lu.h,
	lib/unistring/unictype/categ_M.c, lib/unistring/unictype/categ_M.h,
	lib/unistring/unictype/categ_Mc.c,
	lib/unistring/unictype/categ_Mc.h,
	lib/unistring/unictype/categ_Me.c,
	lib/unistring/unictype/categ_Me.h,
	lib/unistring/unictype/categ_Mn.c,
	lib/unistring/unictype/categ_Mn.h,
	lib/unistring/unictype/categ_N.c, lib/unistring/unictype/categ_N.h,
	lib/unistring/unictype/categ_Nd.c,
	lib/unistring/unictype/categ_Nd.h,
	lib/unistring/unictype/categ_Nl.c,
	lib/unistring/unictype/categ_Nl.h,
	lib/unistring/unictype/categ_No.c,
	lib/unistring/unictype/categ_No.h,
	lib/unistring/unictype/categ_P.c, lib/unistring/unictype/categ_P.h,
	lib/unistring/unictype/categ_Pc.c,
	lib/unistring/unictype/categ_Pc.h,
	lib/unistring/unictype/categ_Pd.c,
	lib/unistring/unictype/categ_Pd.h,
	lib/unistring/unictype/categ_Pe.c,
	lib/unistring/unictype/categ_Pe.h,
	lib/unistring/unictype/categ_Pf.c,
	lib/unistring/unictype/categ_Pf.h,
	lib/unistring/unictype/categ_Pi.c,
	lib/unistring/unictype/categ_Pi.h,
	lib/unistring/unictype/categ_Po.c,
	lib/unistring/unictype/categ_Po.h,
	lib/unistring/unictype/categ_Ps.c,
	lib/unistring/unictype/categ_Ps.h,
	lib/unistring/unictype/categ_S.c, lib/unistring/unictype/categ_S.h,
	lib/unistring/unictype/categ_Sc.c,
	lib/unistring/unictype/categ_Sc.h,
	lib/unistring/unictype/categ_Sk.c,
	lib/unistring/unictype/categ_Sk.h,
	lib/unistring/unictype/categ_Sm.c,
	lib/unistring/unictype/categ_Sm.h,
	lib/unistring/unictype/categ_So.c,
	lib/unistring/unictype/categ_So.h,
	lib/unistring/unictype/categ_Z.c, lib/unistring/unictype/categ_Z.h,
	lib/unistring/unictype/categ_Zl.c,
	lib/unistring/unictype/categ_Zl.h,
	lib/unistring/unictype/categ_Zp.c,
	lib/unistring/unictype/categ_Zp.h,
	lib/unistring/unictype/categ_Zs.c,
	lib/unistring/unictype/categ_Zs.h,
	lib/unistring/unictype/categ_and.c,
	lib/unistring/unictype/categ_and_not.c,
	lib/unistring/unictype/categ_byname.c,
	lib/unistring/unictype/categ_byname.gperf,
	lib/unistring/unictype/categ_longname.c,
	lib/unistring/unictype/categ_name.c,
	lib/unistring/unictype/categ_none.c,
	lib/unistring/unictype/categ_of.c,
	lib/unistring/unictype/categ_of.h,
	lib/unistring/unictype/categ_or.c,
	lib/unistring/unictype/categ_test.c,
	lib/unistring/unictype/combiningclass.c,
	lib/unistring/unictype/combiningclass.h,
	lib/unistring/uninorm.in.h,
	lib/unistring/uninorm/canonical-decomposition.c,
	lib/unistring/uninorm/composition-table.gperf,
	lib/unistring/uninorm/composition-table.h,
	lib/unistring/uninorm/composition.c,
	lib/unistring/uninorm/decompose-internal.c,
	lib/unistring/uninorm/decompose-internal.h,
	lib/unistring/uninorm/decomposition-table.c,
	lib/unistring/uninorm/decomposition-table.h,
	lib/unistring/uninorm/decomposition-table1.h,
	lib/unistring/uninorm/decomposition-table2.h,
	lib/unistring/uninorm/nfc.c, lib/unistring/uninorm/nfd.c,
	lib/unistring/uninorm/normalize-internal.h,
	lib/unistring/uninorm/u-normalize-internal.h,
	lib/unistring/uninorm/u16-normalize.c,
	lib/unistring/uninorm/u32-normalize.c,
	lib/unistring/uninorm/u8-normalize.c, lib/unistring/unistr.in.h,
	lib/unistring/unistr/u-cpy.h, lib/unistring/unistr/u16-cpy.c,
	lib/unistring/unistr/u16-mbtouc-unsafe-aux.c,
	lib/unistring/unistr/u16-mbtouc-unsafe.c,
	lib/unistring/unistr/u16-mbtoucr.c,
	lib/unistring/unistr/u16-to-u8.c,
	lib/unistring/unistr/u16-uctomb-aux.c,
	lib/unistring/unistr/u16-uctomb.c, lib/unistring/unistr/u32-cpy.c,
	lib/unistring/unistr/u32-mbtouc-unsafe.c,
	lib/unistring/unistr/u32-to-u8.c,
	lib/unistring/unistr/u32-uctomb.c, lib/unistring/unistr/u8-check.c,
	lib/unistring/unistr/u8-cpy.c,
	lib/unistring/unistr/u8-mbtouc-unsafe-aux.c,
	lib/unistring/unistr/u8-mbtouc-unsafe.c,
	lib/unistring/unistr/u8-mbtoucr.c,
	lib/unistring/unistr/u8-to-u16.c, lib/unistring/unistr/u8-to-u32.c,
	lib/unistring/unistr/u8-uctomb-aux.c,
	lib/unistring/unistr/u8-uctomb.c, lib/unistring/unitypes.in.h: lib:
	added unistring sub-library

2016-11-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files for gnutls_utf8_password_normalize()

2016-11-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/str-unicode.c: tests: enhanced str-unicode with
	GNUTLS_UTF8_IGNORE_ERRS flag That is, enhanced to check the tolerable variant of
	gnutls_utf8_password_normalize()

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: added build without libunistring

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS, README.md: doc: mention the RFC7613 normalization and the
	libunistring dependency

2016-11-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/includes/gnutls/gnutls.h.in, lib/srp.c, lib/str-unicode.c,
	lib/str.h, lib/tpm.c, lib/x509/crq.c, lib/x509/pkcs7-crypt.c,
	lib/x509/privkey_openssl.c: tolerate non-valid UTF8 passwords when
	decrypting

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/crl-basic.c, tests/name-constraints-ip.c: tests: addressed
	compiler warnings

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/iconv.c: _gnutls_utf8_to_ucs2: normalize to NFC UTF16
	output

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey_openssl.c: openssl_hash_password: normalize the
	password prior to use

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/tpm.c: TPM: normalize the password prior to use

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/srp.c: _gnutls_calc_srp_sha: normalize the password prior to
	use

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/crq.c: gnutls_x509_crq_set_challenge_password: normalize
	the password prior to use

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in, lib/str-unicode.c,
	lib/str.h, lib/x509/pkcs7-crypt.c: PKCS#7/8: normalize the password
	according to rfc7613

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/gnutls.pc.in: gnutls.pc: use the LT version of the lib
	variables

2016-11-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/gnutls.pc.in, lib/system/iconv.c: Use
	libunistring when present instead of iconv() That allows us to rely to a single provider for unicode
	functionality.

2016-11-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/str-unicode.c: tests: added unit tests
	for gnutls_utf8_password_normalize()

2016-11-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/Makefile.am, lib/includes/gnutls/gnutls.h.in,
	lib/libgnutls.map, lib/str-unicode.c, lib/str.h: Added function for
	UTF-8 normalization based on RFC7613 This introduces gnutls_utf8_password_normalize() and a dependency on
	libunistring.

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am, tests/key-tests/pkcs8-invalid: tests:
	added test suite with PKCS#8 files that have invalid encryption

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: PKCS#5,7 decryption: verify the
	correctness of padding That is, for block ciphers (i.e., cbc), verify that all the padding
	bytes match the expected contents according to RFC2898.  Relates #148

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: PKCS#5,7 decryption: added sanity check on
	padding size Relates #148

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: PKCS#5,7 decryption: fail without leak on
	unknown MAC

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: PKCS#5,7 decryption: fail early on invalid
	block sizes

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c, lib/x509/privkey_pkcs8_pbes1.c,
	lib/x509/x509_int.h: PKCS#5,7 decryption: enforce limits in the
	support parameter sizes This allows to detect invalid parameters early rather than later.
	Relates #148

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files for new functions

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-output.c: pkcs7 output: use the new functions for
	DN output

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/dn.c, tests/x509-dn-decode.c: tests: account for the strict
	RFC4514 compliance reversal Test the new functions only for the strict RFC4514 compliance to
	output strings, and test the old functions for the legacy format.

2016-11-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-11-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/ocsp_output.c, lib/x509/output.c: x509 output: use the
	new functions for DN output

2016-11-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/str.c: cleanups in _gnutls_buffer_to_datum()

2016-11-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: use the new APIs for DN extraction

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/dn.c: _gnutls_x509_get_dn: when no data ensure we return
	GNUTLS_E_REQUESTED_DATA_NOT_AVAILABLE This aligns with the previous (prior to RFC4514 improvements)
	behavior of the function.

2016-11-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/ocsp.h, lib/includes/gnutls/x509.h,
	lib/libgnutls.map, lib/x509/crl.c, lib/x509/crq.c, lib/x509/dn.c,
	lib/x509/ocsp.c, lib/x509/x509.c, lib/x509/x509_dn.c,
	lib/x509/x509_int.h: Introduced new functions to allow multiple DN
	parsing modes The old DN parsing functions are changed to return the original
	non-fully compliant with RFC4514 string format, while the new ones
	return the compliant string by default. This allows applications
	which relied on the previous format to continue functioning without
	changes.

2016-11-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: include root dir log files in all
	builds

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-11-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* gl/m4/gnulib-cache.m4: gl: removed invalid module name

2016-11-13  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/ocsptool-common.c, src/socket.c, src/socket.h: tools: added
	explicit socket flag to skip TLS initialization This allows proper error recovery when SOCKET_FLAG_RAW is specified
	and initialize_session() fails.

2016-11-13  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/cli-debug.c, src/tests.c, src/tests.h: gnutls-cli-debug:
	terminate sessions which cannot be re-used

2016-11-13  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/socket.c: sockets: only use gnutls_bye on a valid socket
	session

2016-11-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/pkcs11.c: p11tool: --initialize will no longer reset user PIN That is because it only resetted the user PIN and not the admin PIN,
	while at the same time it had problems to cope with the case where
	the URL changed between token initialization and PIN setting (which
	is the case if --label is provided to --initialize).

2016-11-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/p11tool-args.def, src/p11tool.c, src/p11tool.h, src/pkcs11.c: 
	p11tool: added options to initialize a user and admin's PIN

2016-11-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/verify-tofu.c: gnutls_store_pubkey: document the default hosts
	format

2016-11-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/pk.c: _wrap_nettle_pk_verify: use FAIL_IF_LIB_ERROR
	prior to returning success This will prevent verification to succeed if the system is in error
	state.

2016-11-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/pk.c, lib/x509/privkey.c: fips140-2: moved PCT-test in
	wrap_nettle_generate_keys This allows it to run in any potential scenario, i.e., any call of
	_gnutls_pk_generate_keys().

2016-11-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-11-06  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: use included libtasn1 in CI
	systems which do not have 4.9

2016-09-03  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* m4/hooks.m4: bumped the version of the minimum required libtasn1 We now require the latest version that supports OIDs with elements
	that are longer than 32-bits.

2016-07-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/certtool-long-oids,
	tests/cert-tests/data/long-oids.pem: tests: added check for the
	decoding of certificates with long OIDs That is, OIDs which have an element which exceeds 2^32.

2016-11-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am: symbol-check: do not compare against symbols not
	exported by us

2016-11-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-11-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/priorities.c: tests: updated known ciphersuites test for
	CHACHA20-POLY1305 in the SECURE set

2016-11-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/priority.c: priorities: added CHACHA20-POLY1305 to SECURE set

2016-11-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: released 3.5.6

2016-11-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, m4/hooks.m4: bumped versions

2016-11-04  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* symbols.last: symbols.last: updated auto-generated file

2016-10-19  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/rng-no-onload.c: tests: added test to
	ensure that gnutls_rnd() is not called during initialization

2016-10-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-backend.h, lib/fips.c: doc: explicitly state that rng
	self_test mustn't require rng initialization

2016-10-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/auth/psk_passwd.c, lib/auth/rsa.c, lib/auth/rsa_psk.c,
	lib/auth/srp_passwd.c, lib/cipher.c, lib/crypto-api.c,
	lib/ext/heartbeat.c, lib/ext/session_ticket.c, lib/handshake.c,
	lib/mpi.c, lib/nettle/pk.c, lib/opencdk/misc.c,
	lib/pkcs11_secret.c, lib/random.h, lib/srp.c, lib/tpm.c,
	lib/x509/pkcs12.c, lib/x509/pkcs7-crypt.c: deprecated _gnutls_rnd()
	in favor of exported gnutls_rnd()

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/global.c, lib/locks.h, lib/nettle/rnd-fips.c,
	lib/nettle/rnd.c, lib/random.c, lib/random.h: rng: split
	initialization in preinit and init This makes gnutls to initialize its random generator on the first
	call to gnutls_rnd(). That prevents blocking due to getrandom() on a
	constructor; that change allows to use gnutls-linked applications
	even in early boot in systems where getrandom() blocks waiting for
	entropy.

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-backend.h, lib/nettle/rnd-fips.c, lib/nettle/rnd.c,
	lib/random.h: _gnutls_rnd_check: call _rnd_system_entropy_check
	directly

2016-11-02  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/gnutls-idna.c: x509: removed unused IDNA file

2016-11-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update [ci skip]

2016-11-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/handshake.c: handshake: log advertized version

2016-11-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/algorithms.h: algorithms.h: removed exported prototype from
	internal header

2016-11-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-gtls-app.texi, doc/cha-intro-tls.texi: doc update

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/multi-value-dn.pem,
	tests/cert-tests/pem-decoding: tests: added decoding of multi-value
	DN

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/x509_dn.c: x509_dn: forbid non-supported escaped chars on
	DN encoding

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/x509-dn-decode.c: tests: enhanced RFC4514 with arbitrary
	escaped strings

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/x509_dn.c: x509_dn: allow arbitrary escaped strings In addition fail encoding on unescaped '+'. We do not support it for
	DN encoding.

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/data/aki-cert.pem,
	tests/cert-tests/data/arb-extensions.csr,
	tests/cert-tests/data/bmpstring.pem,
	tests/cert-tests/data/complex-cert.pem,
	tests/cert-tests/data/gost-cert.pem,
	tests/cert-tests/data/name-constraints-ip2.pem,
	tests/cert-tests/data/no-ca-or-pathlen.pem,
	tests/cert-tests/data/template-tlsfeature.csr,
	tests/cert-tests/data/very-long-dn.pem,
	tests/cert-tests/data/xmpp-othername.pem,
	tests/cert-tests/templates/template-dn.tmpl,
	tests/cert-tests/templates/template-krb5name.tmpl,
	tests/cert-tests/templates/template-nc.tmpl,
	tests/cert-tests/templates/template-othername-xmpp.tmpl,
	tests/cert-tests/templates/template-othername.tmpl,
	tests/cert-tests/templates/template-unique.tmpl, tests/crq_apis.c,
	tests/crt_apis.c, tests/dn.c, tests/dn2.c, tests/ocsp.c,
	tests/rfc2253-escape-test, tests/suite/crl/long.pem,
	tests/suite/data/test1.cat.out, tests/x509-dn-decode.c: tests:
	modified to account for backwards-encoded DN (according to RFC4514)

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am, tests/key-tests/README: tests:
	removed old README file The description in the file had no relevance to the existing tests.

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/x509_dn.c: gnutls_x509_crt_set_*dn,
	gnutls_x509_dn_set_str: honor the reverse property of RFC4514 When converting an RFC4514 string to a DN ensure that the elements
	are encoded in reverse order, as required by the RFC.  Resolves #111

2016-07-19  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/dn.c: Encode string DNs backwards according to RFC4514 This makes the output string from functions such as
	gnutls_x509_crt_get*dn() to comply with RFC4514 requirements in DN
	element order.  Relates #111

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab/issue_templates/Bug.md: Updated issue templates [ci skip]

2016-10-31  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab/issue_templates/Bug.md,
	.gitlab/issue_templates/Feature.md: Added issue templates [ci skip]

2016-10-29  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update [ci skip]

2016-10-29  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/nettle/Makefile.am, lib/nettle/{rnd-getentropy.c =>
	sysrng-getentropy.c}, lib/nettle/{rnd-linux.c => sysrng-linux.c},
	lib/nettle/{rnd-windows.c => sysrng-windows.c}, tests/rng-sigint.c: 
	nettle: renamed system random generator-related files for clarity

2016-10-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/rng-pthread.c: tests: introduced checks
	for gnutls_rnd() in multi-threaded scenario

2016-10-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/rng-fork.c: tests: introduced sanity checks in rng-fork

2016-10-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/int/drbg-aes-self-test.c: drbg-aes-self-test: corrected
	free call

2016-10-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/status-request-ext.c: tests: check for
	gnutls 3.3.x compatibility That is, check whether the status request extension is not sent by
	the server, if the server does not hold a status response. We
	require that behavior to be backwards compatible with gnutls 3.3.x.

2016-10-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c, lib/gnutls_int.h, lib/handshake.c,
	lib/includes/gnutls/gnutls.h.in: Reverted the behavior of sending a
	status request extension even without a response That is, we no longer reply to a client's hello with a status
	request, with a status request extension. Although that behavior
	which was introduced in 6b76e0c899b1ff08df9bd9b41588f771f050be89 is
	legal, it creates incompatibility issues with gnutls 3.3.x branch.
	That is because versions prior 3.3.26 translates the presence of the
	extension as a guarrantee that the status response data will be
	sent. Even though, that is false assumption we replicate the
	previous behavior to allow such clients to connect to a gnutls 3.5.x
	server.  Relates !66

2016-10-27  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* tests/suite/Makefile.am: tests: do not enable testpkcs11.sh twice Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-10-22  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* tests/starttls.sh: starttls: search for chat in sbin if it is not
	present in PATH Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-10-21  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* src/libopts/m4/libopts.m4: Fix autoconf warnings in libopts.m4 Without this patch Autoconf will spam console with the following
	kind of messages: configure.ac:650: warning: AC_LANG_CONFTEST: no AC_LANG_SOURCE call
	detected in body ../../lib/autoconf/lang.m4:193: AC_LANG_CONFTEST is
	expanded from...  ../../lib/autoconf/general.m4:2740: _AC_RUN_IFELSE
	is expanded from...  ../../lib/m4sugar/m4sh.m4:639: AS_IF is
	expanded from...  ../../lib/autoconf/general.m4:2759: AC_RUN_IFELSE
	is expanded from...  ../../lib/m4sugar/m4sh.m4:639: AS_IF is
	expanded from...  ../../lib/autoconf/general.m4:2042: AC_CACHE_VAL
	is expanded from...  src/libopts/m4/libopts.m4:386:
	LIBOPTS_RUN_FOPEN_TEXT is expanded from...
	src/libopts/m4/libopts.m4:425: INVOKE_LIBOPTS_MACROS is expanded
	from...  src/libopts/m4/libopts.m4:560: AM_COND_IF is expanded
	from...  src/libopts/m4/libopts.m4:581: LIBOPTS_CHECK is expanded
	from...  configure.ac:650: the top level Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-10-22  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* cfg.mk: cfg.mk: fix m4 files removal Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/long-session-id.c: tests: better check for
	gnutls_ecc_curve_get result

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/alert.c, lib/ext/signature.c: Terminate handshake if only
	unknown or disabled signatures are advertized by the peer That is, do not attempt to proceed assuming that the peer supports
	SHA-1.

2016-10-22  Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

	* tests/Makefile.am, tests/slow/Makefile.am,
	tests/slow/cipher-override2.c, tests/suite/Makefile.am: Fix
	compilation of tests if nettle is not installed in standard path Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

2016-10-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli-debug.c: gnutls-cli-debug: corrected TLS1.2 detection

2016-10-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-22  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-gtls-app.texi, doc/examples/ex-serv-x509.c,
	lib/ext/status_request.c, lib/includes/gnutls/gnutls.h.in,
	lib/x509.c, tests/Makefile.am, tests/set_key.c,
	tests/set_x509_key.c, tests/set_x509_key_file.c,
	tests/set_x509_key_file_legacy.c,
	tests/set_x509_key_file_ocsp_multi.c,
	tests/set_x509_key_file_ocsp_multi2.c, tests/set_x509_key_utf8.c: 
	modified the gnutls_certificate_set_key* change While the change was fully backwards compatible for applications
	that were adding a single certificate, and applications that were
	checking for negative errors codes, many applications do not. As
	this may cause incompatibility issues with software properly
	utilizing the previously documented API, the change is reverted, and
	applications need to explicitly enable a flag
	(GNUTLS_CERTIFICATE_API_V2) in the credentials structure for the
	set_key functions to return an index.

2016-10-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testdane.sh: tests: removed nohats.ca from testdane The host seems to be unreliable.

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .travis.yml: .travis.yml: use as many jobs as CPUs in OSX

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .travis.yml: .travis.yml: do not run the public submodule checks
	of maint.mk These seem to be problematic to detect modification and are
	preventing the CI from operating.

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .travis.yml: .travis.yml: simplified the submodule checkout The default submodule initialization in travis caused the MacOSX
	builds to fail.

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/atfork.c, lib/pubkey.c: Added casts to prevent compiler
	warnings

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/session.c: corrected typo

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* README.md: README.md: corrected link to travius build

2016-10-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .travis.yml, README.md, cfg.mk, m4/gettext.m4, m4/nls.m4,
	m4/po.m4, m4/progtest.m4: .travis.yml: added support for compiling
	in macosx

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/session-tickets-missing.c,
	tests/session-tickets-ok.c: tests: added checks for the new
	GNUTLS_NO_TICKETS flag

2016-10-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/gnutls.h.in, lib/state.c: gnutls_init: added
	GNUTLS_NO_TICKETS flags These flags allow the callers to disable the automatically enabled
	session tickets. This could be done only with GNUTLS_NO_EXTENSIONS
	which also disabled other useful extensions.

2016-10-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/pkcs11/pkcs11-privkey-export.c: tests:
	added pkcs11-privkey-export This checks whether the public parts of RSA private and public keys
	can be properly extracted from a PKCS#11 module.

2016-10-19  Jakub Jelen <jjelen@redhat.com>

	* tests/pkcs11/pkcs11-mock.c: Expose CKA_PUBLIC_EXPONENT and
	CKA_MODULUS for private keys too

2016-10-19  Jakub Jelen <jjelen@redhat.com>

	* tests/pkcs11/pkcs11-mock.c: tests/pkcs11: Return also CKA_CLASS

2016-10-18  Jakub Jelen <jjelen@redhat.com>

	* tests/pkcs11/pkcs11-mock.c: tests/pkcs11: Expose SUBJECT for
	certificates, PUBLIC_EXPONENT and MODULUS for public keys to widen
	compatibility

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS, lib/x509/pkcs7.c, lib/x509/x509.c: doc update [ci skip]

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS, lib/x509/pkcs7.c: doc update

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: allow setting key purposes for non-CA
	certificates That is, allow setting code signing, or time stamping key purpose in
	certificates that are not marked as CA. The previous restriction
	served no purpose.

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: introduce key purpose checks in p7
	direct verification

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/x509.h, lib/libgnutls.map, lib/x509/x509.c: 
	x509: introduced gnutls_x509_crt_check_key_purpose()

2016-10-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in, lib/x509/pkcs7.c,
	lib/x509/x509.c, lib/x509/x509_int.h: gnutls_x509_crt_verify_data2:
	introduce constraints checks on the provided certificate That is check the provided certificate for validity in time and key
	usage.

2016-10-18  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am,
	tests/cert-tests/data/code-signing-ca.pem,
	tests/cert-tests/data/code-signing-cert.pem,
	tests/cert-tests/pkcs7, tests/cert-tests/pkcs7-constraints,
	tests/cert-tests/pkcs7-constraints2, tests/pkcs7-gen.c,
	tests/suite/pkcs7-cat: tests: introduced verification constraints
	checks for PKCS#7 structures That is, key purpose checks and more elaborate time checks.

2016-10-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/credentials/gnutls-http-serv, src/serv.c: gnutls-serv: use the
	included known DH parameters by default

2016-10-17  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-args.def: certtool: manpage update

2016-10-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/scripts/getfuncs-map.pl: getfuncs-map.pl: ignore the ffdhe
	exported parameters That is ignore the new variables exported which are not functions,
	and thus cannot be detected by getfuncs-map.pl.

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/crl-test: tests: crl-test: use a unique temp file

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/Makefile.am, tests/suite/prime-check.c: tests: added
	sanity check for included primes

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-bib.texi, doc/cha-gtls-app.texi,
	doc/examples/ex-serv-anon.c, doc/examples/ex-serv-dtls.c,
	doc/examples/ex-serv-psk.c, doc/examples/ex-serv-x509.c,
	doc/latex/gnutls.bib: doc: discuss the set_known_dh_params and use
	it in the examples

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/set_known_dh_params_psk.c,
	tests/utils-adv.c, tests/utils.h: tests: check
	gnutls_psk_set_server_known_dh_params

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/set_known_dh_params_anon.c,
	tests/utils-adv.c, tests/utils.h: tests: check
	gnutls_anon_set_server_known_dh_params

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/set_known_dh_params_x509.c: tests: check
	gnutls_certificate_set_known_dh_params

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/anon_cred.c, lib/auth/anon.h, lib/auth/cert.h,
	lib/auth/psk.h, lib/cert.c, lib/dh-primes.c, lib/dh.h,
	lib/includes/gnutls/gnutls.h.in, lib/libgnutls.map, lib/psk.c: DH:
	introduced gnutls_*_set_known_dh_params() That is, the functions gnutls_certificate_set_known_dh_params(),
	gnutls_anon_set_server_known_dh_params(),
	gnutls_psk_set_server_known_dh_params().  These functions allow to
	statically set the DH parameters, based on the RFC7919 FFDHE
	parameters. This can simplify server configuration by allowing DH
	without loading parameters from file.  Relates #37

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-common.c: certtool: --get-dh-params will output the
	FFDHE primes instead of the SRP primes

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/Makefile.am, lib/dh-primes.c,
	lib/includes/gnutls/gnutls.h.in, lib/libgnutls.map: DH: export the
	FFDHE Diffie-Hellman values

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: use fedora's mingw-cmocka packages

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore: more files to ignore

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/pkcs7-cat-parse.c: tests: added check for
	PKCS#7 catalog file parsing and data extracting

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/data/full.p7b.out,
	tests/cert-tests/data/single-ca.p7b.out,
	tests/suite/data/test1.cat.out, tests/suite/data/test2.cat.out: 
	tests: updated pkcs7 text outputs to account for certtool update

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: --p7-info will include the PKCS#7
	encoded data in PEM format

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/suite/data/test2.cat.out: tests: replaced large test2.cat
	with a smaller file

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-common.c: certtool: improve text on missing options
	for cert generation

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: Revert "certtool: improve text on missing options
	for cert generation" This reverts commit 7daed1fd0602bce7495d252f1a9b638fc41e38d3.

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/gnutls_int.h, lib/handshake.c, lib/state.c: handshake: set a
	maximum number of warning messages that can be received per
	handshake That is to avoid DoS due to the assymetry of cost of sending an
	alert vs the cost of processing.

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/record.c: record: disallow parsing of alert messages prior to
	session start

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/naked-alerts.c: tests: added check to
	verify that the server will bail out after receiving only alerts

2016-10-14  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/multi-alerts.c: tests: added check to
	verify that the server will bail out after many alerts

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: improve text on missing options for cert
	generation

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/common.c: tools: removed redudant messages on PIN re-use

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/pkcs11.c: p11tool: avoid asking the security officer PIN twice
	on initialization

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/pkcs11.c: p11tool: improved messages on token initialization

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/pkcs11.c: p11tool: corrected check of PIN existance in token
	initialization

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/examples/ex-serv-x509.c: doc: set a default handshake timeout
	on example server

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/serv.c: serv: set a timeout value in handshake

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/dtls-etm.c: tests: added check for
	Encrypt-then-MAC under DTLS

2016-10-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/{mini-etm.c => tls-etm.c}: tests:
	cleanups in tls-etm.c

2016-10-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/pkcs7.h, lib/x509/pkcs7.c: 
	gnutls_pkcs7_get_embedded_data: added GNUTLS_PKCS7_EDATA_GET_RAW
	flag This flag allows the export of the stored embedded data with any
	wrapping encoding included. This in particular, it allows to read
	the data from the microsoft catalog PKCS#7 structures, which store
	as embedded data elements of a SEQUENCE, but only authenticate the
	inner parts without the bytes forming the SEQUENCE header.

2016-10-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac: configure: automatically disable non-suiteb curves That is, if the installed nettle doesn't provide the
	nettle_secp_192r1 symbol.

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-10-11  Colin Walters <walters@verbum.org>

	* lib/priority.c: priorities: Do read crypto policy files with mtime
	of zero In a default Fedora Atomic Host installation,
	`/etc/crypto-policies/backends/gnutls.config` is a symlink to the
	default in `/usr/share/`.  On an OSTree-managed system, files in
	`/usr` have an mtime of zero (to help deduplication).  The simple fix here is to still try to read the first time, even if
	the file has an mtime of zero.

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: corrected use of
	gnutls_pkcs7_get_embedded_data()

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkix.asn, lib/pkix_asn1_tab.c: pkix.asn: simplified ASN.1
	description by eliminating pkcs-7-ContentType

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files

2016-10-11  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: print the enacapsulated content OID on
	verification

2016-10-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/suite/Makefile.am, tests/suite/data/ca.pem,
	tests/suite/data/test1.cat.out, tests/suite/data/test2.cat.out,
	tests/suite/pkcs7-cat: tests: added checks for the decoding of
	various PKCS#7 structures

2016-10-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-output.c, lib/x509/pkcs7.c, lib/x509/pkcs7_int.h: 
	pkcs7: print the eContent type in output functions if it does not
	match the defaults

2016-10-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/pkcs7.h, lib/libgnutls.map, lib/pkix.asn,
	lib/pkix_asn1_tab.c, lib/x509/pkcs7.c, lib/x509/x509_int.h: pkcs7:
	allow unknown and legacy signature data OIDs to be imported This allows to decode very old PKCS#7 structures where the content
	is not an octet string. In addition, it introduces
	gnutls_pkcs7_get_embedded_data_oid() to obtain the OID of the
	signature data.

2016-10-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/certtool-args.def, src/certtool.c: certtool: --p7-info can be
	combined with --p7-show-data to display embedded data

2016-10-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/Makefile.am: lib: link with LTLIBDL instead of LIBDL It fixes compilation issues on some systems.

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: released 3.5.5

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-internals.texi: doc: mention gnutls_session_ext_register
	and its supplemental data equivalent

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, m4/hooks.m4: bumped version

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/extensions.c: TLS extensions: only cache the extension IDs
	from exts that the server supports That avoids imposing any artificial limits on the number of
	extensions that a server can handle.  Resolves #136

2016-10-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/tls-session-ext-register.c: tests: check the registration of
	multiple extensions

2016-10-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/cha-gtls-app.texi: doc: added gnutls_datum_t and giovec_t to
	indexes Resolves #137

2016-10-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-output.c: pkcs7: removed any limits in hex encoding
	of attributes

2016-10-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: lift any limits in print_raw()

2016-10-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool.c: certtool: added safety net when generating a
	certificate request That is, do not allow specifying --generate-request --load-pubkey
	without specifying --load-privkey. Previously if --load-pubkey would
	have been used, it would have been ignored, causing confusion to the
	users.

2016-10-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update [ci skip]

2016-10-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* Makefile.am: Makefile.am: improved the files-update output

2016-10-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/iconv.c: _gnutls_utf8_to_ucs2: force NFC normalization
	form in windows

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/tls-session-supplemental.c,
	tests/{mini-supplementaldata.c => tls-supplemental.c}: tests: added
	checks for gnutls_session_supplemental_register

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/gnutls_int.h, lib/includes/gnutls/gnutls.h.in,
	lib/libgnutls.map, lib/state.c, lib/supplemental.c: Added
	session-specific supplemental data handling This allows a caller to add supplemental data handling which will
	only be made available for a specific session.

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/{mini-extension.c =>
	tls-ext-register.c}, tests/tls-session-ext-register.c: tests: added
	checks for gnutls_session_ext_register

2016-09-30  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/extensions.c, lib/extensions.h, lib/gnutls_int.h,
	lib/includes/gnutls/gnutls.h.in, lib/libgnutls.map, lib/state.c: 
	Added session-specific TLS extensions This allows a caller to add extensions which will be made available
	for a specific session.

2016-10-05  Ludovic Courtès <ludo@gnu.org>

	* guile/src/core.c: guile: Implement session record ports using the
	Guile 2.2 API.  This allows the Guile bindings to be built and used with Guile >=
	2.1.4, which introduced a new port API.  * guile/src/core.c (USING_GUILE_BEFORE_2_2): New macro.  (session_record_port_type) [!USING_GUILE_BEFORE_2_2]: New
	definition.  (read_from_session_record_port, write_to_session_record_port) (make_session_record_port) [!USING_GUILE_BEFORE_2_2]: New functions.
	Conditionalize the other same-named functions on
	USING_GUILE_BEFORE_2_2.  (scm_init_gnutls_session_record_port_type): Use
	'read_from_session_record_port' when !USING_GUILE_BEFORE_2_2.

2016-10-05  Ludovic Courtès <ludo@gnu.org>

	* guile/tests/session-record-port.scm: guile: Test
	'set-session-transport-fd!'.  * guile/tests/session-record-port.scm: Use
	'set-session-transport-fd!' on the server side.

2016-10-05  Ludovic Courtès <ludo@gnu.org>

	* guile/modules/gnutls/build/tests.scm: guile: Guile 2.x
	'uniform-vector-read!' replacement returns 0 upon EOF.  This problem was never hit in practice because our tests always got
	the non-EOF case.  * guile/modules/gnutls/build/tests.scm (uniform-vector-read!)
	[guile-2]: Return 0 upon EOF.

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* extra/Makefile.am, lib/Makefile.am: win32: install the .def files
	in libdir instead of bindir Suggested by Eli Zaretskii.

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-cfg.c: certtool: include arpa/inet.h unconditionally That is because we use inet_pton() which is either provided by the
	OS, or by gnulib.

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/benchmark.c: gnutls-cli: fix compilation warning in win32

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* extra/Makefile.am, m4/hooks.m4: Fixed the version in
	libgnutls-openssl.def file Previously the version set in that file would have been
	(incorrectly) equal to the version of the main library.

2016-10-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/certuniqueid.c, tests/mini-dtls-mtu.c: tests: avoid using
	%zd for formatted output It is not supported by windows.

2016-10-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/set_key_utf8.c, tests/set_x509_key_utf8.c: tests: skip tests
	which depend on libidn functionality if build without libidn

2016-10-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: fixed compilation of
	pkcs11-privkey-always-auth

2016-10-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/keys-win.c: Fix build of system/keys-win.c with older
	mingw Patch by Eli Zaretskii <eliz@gnu>

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/provable-dh, tests/cert-tests/provable-privkey,
	tests/cert-tests/provable-privkey-dsa2048,
	tests/cert-tests/provable-privkey-rsa2048: tests: introduced further
	parallelization in provable* tests This runs independent verification steps in parallel, improving
	running time significantly.

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am: tests: provable-dh-default check is
	too slow and is only run when the complete suite is requested

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am, tests/cert-tests/provable-privkey,
	tests/cert-tests/provable-privkey-dsa2048,
	tests/cert-tests/provable-privkey-gen-default,
	tests/cert-tests/provable-privkey-rsa2048: tests: split
	provable-privkey into multiple checks This allows the tests to be run in parallel.

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am, tests/cert-tests/provable-dh,
	tests/cert-tests/provable-dh-default: tests: provable-dh was split
	into two programs This allows the test to be run more efficiently when run in
	parallel.

2016-09-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml, configure.ac: .gitlab-ci.yml: do not run the full
	test suite on valgrind test This allows the CI test to run on reasonable time.

2016-09-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore: more files to ignore

2016-09-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* devel/openssl: devel/openssl: updated to 1.1.0 release

2016-09-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/accelerated/aarch64/Makefile.am,
	lib/accelerated/aarch64/aarch64-common.c,
	lib/accelerated/aarch64/aes-aarch64.h,
	lib/accelerated/aarch64/aes-ccm-aarch64.c: aarch64: added optimized
	AES-CCM mode

2016-09-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* cfg.mk, devel/perlasm/ghash-aarch64.pl,
	devel/perlasm/ghash-aarch64.pl.license,
	lib/accelerated/aarch64/Makefile.am,
	lib/accelerated/aarch64/aarch64-common.c,
	lib/accelerated/aarch64/aes-gcm-aarch64.c,
	lib/accelerated/aarch64/elf/ghash-aarch64.s: Imported Andy
	Polyakov's implementation of AES-GCM in aarch64

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk, devel/perlasm/aes-aarch64.pl,
	devel/perlasm/aes-aarch64.pl.license,
	lib/accelerated/aarch64/Makefile.am,
	lib/accelerated/aarch64/aarch64-common.c,
	lib/accelerated/aarch64/aes-aarch64.h,
	lib/accelerated/aarch64/aes-cbc-aarch64.c,
	lib/accelerated/aarch64/aes-gcm-aarch64.c,
	lib/accelerated/aarch64/elf/aes-aarch64.s: Imported Andy Polyakov's
	implementation of AES in aarch64

2016-09-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/accelerated/aarch64/Makefile.am,
	lib/accelerated/aarch64/aarch64-common.c,
	lib/accelerated/aarch64/hmac-sha-aarch64.c,
	lib/accelerated/aarch64/sha-aarch64.h: Added HMAC-SHA* optimizations
	for aarch64

2016-09-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* cfg.mk, configure.ac, devel/perlasm/arm-xlate.pl,
	devel/perlasm/sha1-armv8.pl, devel/perlasm/sha1-armv8.pl.license,
	devel/perlasm/sha256-armv8.pl,
	devel/perlasm/sha256-armv8.pl.license,
	devel/perlasm/sha512-armv8.pl,
	devel/perlasm/sha512-armv8.pl.license, lib/accelerated/Makefile.am,
	lib/accelerated/aarch64/Makefile.am,
	lib/accelerated/aarch64/README,
	lib/accelerated/aarch64/aarch64-common.c,
	lib/accelerated/aarch64/aarch64-common.h,
	lib/accelerated/aarch64/elf/sha1-armv8.s,
	lib/accelerated/aarch64/elf/sha256-armv8.s,
	lib/accelerated/aarch64/elf/sha512-armv8.s,
	lib/accelerated/aarch64/sha-aarch64.c,
	lib/accelerated/aarch64/sha-aarch64.h,
	lib/accelerated/accelerated.c: Imported Andy Polyakov's
	implementations for SHA* in aarch64

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/server_name.c, lib/ext/server_name.h: fix zero-termination
	in _gnutls_server_name_set_raw() for large server names

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/handshake-checks.c: _gnutls_check_id_for_change: added check
	for NULL username This is not required, but may prevent from issues if
	code-reorganizations which may set a NULL username, occur.

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/openpgp/output.c, lib/x509/output.c: gnutls_*_crt_print:
	better error checking

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore, tests/Makefile.am, tests/pkcs11/pkcs11-mock-ext.h,
	tests/pkcs11/pkcs11-mock.c,
	tests/pkcs11/pkcs11-privkey-always-auth.c: tests: added test for
	CKA_ALWAYS_AUTHENTICATE handling in PKCS#11 This checks whether GnuTLS properly calls login prior to any sign
	operations when the object is marked as CKA_ALWAYS_AUTHENTICATE.

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11.c: pkcs11: improved debugging output in pkcs11_login

2016-10-03  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/name_constraints.c: name constraints: removed unused
	variable

2016-09-30  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-common.c, src/ocsptool.c: tools: clarify errors when
	reading files Previously certtool and ocsptool would report: ``` $ certtool
	--generate-request --load-privkey=foo --outfile=bar Generating a
	PKCS #10 certificate request...  reading --load-privkey: foo ``` And that doesn't make apparent what the issue was. Modified to
	print: ``` error reading --load-privkey: foo ``` Report and initial patch by Thibault Nélis.  Resolves !97

2016-09-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/p11tool-args.def: p11tool: doc update [ci skip]

2016-09-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/ip-in-cidr.h, lib/x509/ip.c, lib/x509/name_constraints.c: 
	Removed C99 constructions in for-loops These constructions although valid for C99 they are being rejected
	by various compilers. Get rid of them.

2016-09-27  Daiki Ueno <dueno@redhat.com>

	* src/certtool.c: certtool: print correct size of EC keys Previously certtool complained about key size if --curve is given:  $ certtool --generate-privkey --ecc --curve secp256r1 --outfile
	 key.pem Generating a -2147483646 bit EC/ECDSA private key...   Note that ECDSA keys with size less than 256 are not widely
	 supported.

2016-09-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/p11tool-args.def: p11tool: documented the p11-kit relevancy of
	distrust and stapled

2016-09-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* devel/openssl, lib/pkcs11.c, lib/pkcs11_int.h,
	lib/pkcs11_write.c, lib/pkcs11x.c: pkcs11: forbid PKCS#11 extensions
	to be used in other than trust modules That is, only use the CKA_X_DISTRUSTED and the extension override in
	p11-kit trust modules, to avoid conflicts with potentially other
	PKCS#11 extensions.

2016-09-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: enabled valgrind tests build

2016-09-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/handshake-large-packet.c: tests: allow
	handshake-large-packet to run under valgrind That is, initialize the allocated buffers with a known value.

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/p11tool-args.def, src/p11tool.c: p11tool: introduced the
	--mark-distrusted and --distrusted options This allows to mark objects as distrusted, as well as list all
	distrusted certificates (blacklisted) for a p11-kit trust module as:
	p11tool --list-all-certs --distrusted

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/pkcs11.h, lib/pkcs11.c, lib/pkcs11_write.c: 
	pkcs11: introduced flag GNUTLS_PKCS11_OBJ_FLAG_MARK_DISTRUSTED This allows to mark objects as distrusted, as well as to be able to
	list distrusted objects.

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11.c, lib/pkcs11x.c: pkcs11: only staple extensions from a
	trust module when they are from a non-distrusted certificate That is, make sure that the API for stapling extensions is only used
	for non-distrusted (blacklisted) certificates. The reason is to
	avoid duplicate extension entries from the p11-kit trust database.
	These come from blacklisted certificates, and we have no reason to
	support stapled extensions with blacklisted certificates.

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/p11tool-args.def, src/p11tool.c: p11tool: allow to export a
	certificate with its stapled extensions

2016-09-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/algorithms/ecc.c: gnutls_oid_to_ecc_curve: fix null pointer
	dereference This addresses issue where an unknown curve would cause a null
	pointer dereference. This was introduced with the addition of
	X25519. Reported by Theofilos Petsios.

2016-09-23  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c: Only send the status request extension
	on cert authentication That is, do not both asking for it, or replying to it, if we are not
	using any certificates.

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/scripts/gdoc: gdoc: improved the detection and display of
	escaped characters (@%) This allows to properly display strings like %COMPAT and @SYSTEM in
	the manual and the manpages.

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/priority.c: doc: gnutls_priority_init: fixed %COMPAT [ci skip]

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: corrected debian build's
	dependency

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-21  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/signature.c, lib/ext/signature.h, lib/tls-sig.c: On client
	side allow signing with the signature algorithm of our cert That allows to sign for example with DSA-SHA1 as client even if we
	do not allow DSA-SHA1 as signature algorithm for server's
	certificate. This allows to use a deprecated certificate without
	enabling deprecated algorithms globally.

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/signature.c: _gnutls_session_get_sign_algo: always return
	GNUTLS_SIGN_UNKNOWN on failure

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-common.h, tests/server_ecdsa_key.c,
	tests/utils-adv.c, tests/utils.h: tests: added check for server-side
	ECDSA keys These tests check whether a server ECDSA key will be rejected by the
	client in case the client has no ECDSA signature algorithms
	available.

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-common.h, tests/client_dsa_key.c,
	tests/utils-adv.c, tests/utils.h: tests: added check for client-side
	DSA key This checks whether a client can use and send a DSA key, even if DSA
	is not enabled (which should prohibit the server from providing a
	DSA certificate).

2016-09-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/certtool-args.def, src/certtool.c: certtool: do not require a
	certificate to generate a PKCS#12 file That is, allow generating PKCS#12 files with private keys only as
	well.

2016-09-20  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: added debian build

2016-09-20  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* README.md: README.md: depend on softhsm2 and net-tools on debian

2016-09-19  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-server-name.c: tests: mini-server-name: skip invalid
	UTF-8 check if compiled without libidn This allows the test suite to run in systems without libidn.
	Reported by Thomas Klausner.

2016-09-19  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-server-name.c, tests/mini-session-verify-function.c,
	tests/utils.h, tests/x509-dn-decode.c: tests: added the macros
	test_fail() and test_success() These macros allow test programs which run multiple checks, to
	report the name of the check failed. Modified mini-server-name and
	x509-dn-decode to use the macro.

2016-09-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* cfg.mk: cfg.mk: removed invalid rule in web target

2016-09-19  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-19  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/handshake.c: added debugging message when session fails due to
	handshake hash buffer

2016-09-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/handshake-large-packet.c: tests: check
	whether large packets are allowed on the handshake

2016-09-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/extensions.c: Do not allow sending overflowed extensions field That is, restrict the extensions to a 2^16 total size.

2016-09-19  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/mini-extension.c: tests: minor improvements in
	mini-extension This will improve recovery from error conditions.

2016-09-16  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/gnutls_int.h, lib/handshake.c: Increased the maximum size
	allowed for handshake messages to 128kb This would allow the library to cope with larger packets, as well as
	TLS 1.3 hellos. Suggested by Hubert Kario.

2016-09-17  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/Makefile.am, tests/cert-common.h, tests/insecure_key.c,
	tests/utils-adv.c, tests/utils.h: tests: added check for insecure
	key That is, a check which verified whether a connection to a server
	with a very small key will fail the certificate verification check.

2016-09-17  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-09-17  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in, lib/nettle/pk.c,
	tests/rsa-illegal-import.c: Introduced separate error codes for
	invalid private and public keys This allows functions like decryption and verification to report the
	specific issue they encountered on public key error.  The new codes
	are GNUTLS_E_PK_INVALID_PUBKEY and GNUTLS_E_PK_INVALID_PRIVKEY

2016-09-15  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: no longer require gnutls-devel This package is no longer needed to run abi-check.

2016-09-15  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am: Makefile: abi-check no longer require gnutls headers
	to be installed This addresses the issue of requiring gnutls-devel in the CI system
	to run abi-check.

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/manpages/Makefile.am: doc: remove the conditional self_test
	functions Also prevent them by re-entering the documented functions list by
	restricting the header files that contribute functions to the known
	list defined by $(HEADER_FILES).

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am, doc/Makefile.am, doc/manpages/Makefile.am: 
	Makefile.am: introduced 'make files-update' rule This rule updates the makefiles in doc/ and the kept symbol list.
	This allows for easier automation of the symbol change 'make dist'
	breakages.

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/manpages/Makefile.am: manpages: delete comparison temp file

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am: Makefile.am: symbol changes were made more elaborate During make dist, the makefile will report the appropriate symbol
	change message with instructions and fail.

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	doc and symbol files for
	gnutls_certificate_set_ocsp_status_request_function2

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am: Makefile.am: print the symbols.last diff on make dist This allows to manually verify the contents before overriding the
	old file.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am: doc: allow creation of gnutls.epub without
	running epub-fix

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: use nproc as argument to 'make -j' That way, we use as many make processes, as the number of CPUs in
	the CI system.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: added build which runs 'make dist' This tests whether the manpages, info, html, pdf and epub manual are
	properly generated, and whether any new functions were included into
	makefiles.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/epub.texi: doc: fixed the epub documentation generation

2016-09-13  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/ext/status_request.c: 
	gnutls_certificate_set_ocsp_status_request_file: mention version it
	was enhanced

2016-09-13  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc: corrected typo

2016-09-12  Alex Monk <krenair@gmail.com>

	* doc/cha-gtls-app.texi: Add ECDHE-* to the priority string docs for
	key exchange algorithms GNUTLS_KX_ECDHE_PSK was added in 2.99.3 (released 2011-06-18) The
	other two were added in 2.99.2 (released 2011-05-26) Signed-off-by: Alex Monk <krenair@gmail.com>

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: added check for position dependent
	code

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am: Makefile.am: added check for position dependent code This check will verify that the generated library doesn't contain
	position dependent code. It depends on elf utilities.

2016-09-13  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/accelerated/x86/coff/aesni-x86.s,
	lib/accelerated/x86/elf/aesni-x86.s,
	lib/accelerated/x86/macosx/aesni-x86.s: openssl asm: reverted to
	AESNI-x86 code to gnutls 3.4.x code The newer code was creating position dependent code.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-common.h, tests/set_key_utf8.c,
	tests/set_x509_key_utf8.c, tests/utils-adv.c: tests: added checks to
	verify server understanding of UTF8 hostnames This verifies whether a server can understand and serve requests
	which contain UTF-8 server names.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/set_key.c: tests: set_key: fixed the time override

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/set_key.c: tests: set_key: enabled failure_mode test Also eliminated memory leaks related to it.

2016-09-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509.c: Added IDNA support in server side Any server names provided to server side by the
	gnutls_certificate_set_* functions, are converted to IDNA format for
	comparison with client provided values.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: restrict the freebsd builds to
	local branches only

2016-09-11  Alex Monk <krenair@gmail.com>

	* doc/cha-gtls-app.texi: Add SIGN-ECDSA-SHA* to the priority strings
	docs There were added in version 2.99.2, 2011-05-26 Signed-off-by: Alex Monk <krenair@gmail.com>

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509.c: gnutls_certificate_set_*key: ensure proper cleanup on
	key mismatch failures That is, ensure that we keep no local references that are shared
	with the caller, and that we properly free all initialized values.

2016-09-12  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/set_key.c, tests/set_x509_key.c: tests: check key mismatch
	on gnutls_certificate_set_*key That is, check whether these functions can successfully recover from
	such condition, without leaks or double freeing.

2016-09-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/set_x509_key_file_ocsp_multi2.c: tests:
	added unit testing for
	gnutls_certificate_set_ocsp_status_request_function2

2016-09-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/set_key.c, tests/set_x509_key.c: tests:
	added unit tests for gnutls_certificate_set_x509_key() In addition these tests verify that the expected index is returned
	and that can be used with gnutls_certificate_get_crt_raw()
	afterwards.

2016-09-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/set_x509_key.c: tests: enhanced set_x509_key tests to
	include index verification That is, verify that correct indexes are returned, and these can be
	used with gnutls_certificate_get_crt_raw() afterwards.

2016-09-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/set_x509_key_file.c, tests/utils.c, tests/utils.h: tests:
	enhanced set_x509_key_file tests to include index verification That is, verify that correct indexes are returned, and these can be
	used with gnutls_certificate_get_crt_raw() afterwards.

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/set_x509_key_file_ocsp_multi.c,
	tests/utils-adv.c: tests: more checks for functionality of
	gnutls_certificate_set_ocsp_status_request_file This introduces checks for the cases where
	gnutls_certificate_set_ocsp_status_request_file() is called with
	multiple indexes, to set an OCSP response for different
	certificates. The tests then verify whether the expected OCSP
	response is received.

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/auth/cert.c, lib/auth/cert.h, lib/cert.c,
	lib/ext/status_request.c, lib/gnutls_int.h,
	lib/includes/gnutls/gnutls.h.in, lib/libgnutls.map, lib/x509.c: 
	Added gnutls_certificate_set_ocsp_status_request_function2 That introduces a new function to allow setting an OCSP status
	request handling function per certificate. Furthermore it repurposes
	the flag parameters to an index option on
	gnutls_certificate_set_ocsp_status_request_file.  The changes above allow setting a different OCSP status response
	file per certificate, and a different function. The indexes they
	rely on to associate with existing certs are the indexes returned by
	the gnutls_certificate_set_key() and friends functions.

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/cert.c, lib/x509.c: All the key and chain set functions return
	an index When setting key and certificate material to a
	gnutls_certificate_credentials_t structure, the corresponding set
	functions will return an index.  That index could be used later
	either on the get functions, or when setting corresponding data
	(e.g., an OCSP response).

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/status_request.c: doc: clarifications in
	gnutls_certificate_set_ocsp_status_request_function()

2016-09-11  Andreas Metzler <ametzler@bebt.de>

	* lib/x509/x509_write.c, src/ocsptool-args.def: Typo fixes found by
	lintian.  incosistent, ommited

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: added code-coverage output to
	clang build

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: the code-coverage command will
	always succeed This works around random failures while calculating the code
	coverage.

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: moved commonly installed packages
	into the before_script field

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: added syntax check build

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* cfg.mk: cfg.mk: revived 'make release'

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, doc/Makefile.am, doc/examples/ex-pkcs11-list.c,
	doc/gnutls.texi, lib/Makefile.am, lib/algorithms/ciphers.c,
	lib/algorithms/ciphersuites.c, lib/algorithms/ecc.c,
	lib/algorithms/kx.c, lib/algorithms/mac.c,
	lib/algorithms/protocols.c, lib/algorithms/publickey.c,
	lib/algorithms/secparams.c, lib/auth/cert.c, lib/auth/dh_common.c,
	lib/auth/ecdhe.c, lib/auth/psk.c, lib/auth/psk_passwd.c,
	lib/auth/srp_passwd.c, lib/auto-verify.c, lib/buffers.c,
	lib/buffers.h, lib/cipher.c, lib/cipher_int.c, lib/compress.c,
	lib/crypto-api.c, lib/crypto-backend.c, lib/datum.h, lib/dtls-sw.c,
	lib/dtls.c, lib/dtls.h, lib/ecc.c, lib/errors.c, lib/ext/dumbfw.c,
	lib/ext/srp.h, lib/ext/status_request.c, lib/extras/hex.c,
	lib/fips.c, lib/gnutls.asn, lib/gnutls_int.h, lib/handshake.c,
	lib/includes/gnutls/abstract.h, lib/includes/gnutls/crypto.h,
	lib/includes/gnutls/gnutls.h.in, lib/includes/gnutls/x509.h,
	lib/mem.h, lib/minitasn1/decoding.c, lib/minitasn1/element.c,
	lib/minitasn1/libtasn1.h, lib/mpi.c, lib/nettle/cipher.c,
	lib/nettle/int/drbg-aes-self-test.c, lib/nettle/pk.c,
	lib/opencdk/armor.c, lib/opencdk/stream.c, lib/openpgp/openpgp.c,
	lib/pcert.c, lib/pk.c, lib/pkcs11.c, lib/pkcs11_privkey.c,
	lib/pkcs11_write.c, lib/pkcs11x.c, lib/prf.c, lib/privkey.c,
	lib/record.c, lib/session_pack.c, lib/str.c, lib/str.h,
	lib/supplemental.c, lib/system-keys.h, lib/system/inet_ntop.c,
	lib/system/keys-dummy.c, lib/system/keys-win.c, lib/verify-tofu.c,
	lib/x509.c, lib/x509.h, lib/x509/common.c, lib/x509/common.h,
	lib/x509/crl.c, lib/x509/crq.c, lib/x509/email-verify.c,
	lib/x509/extensions.c, lib/x509/hostname-verify.c, lib/x509/krb5.c,
	lib/x509/name_constraints.c, lib/x509/ocsp.c, lib/x509/output.c,
	lib/x509/pkcs12.c, lib/x509/pkcs7-attrs.c, lib/x509/pkcs7-crypt.c,
	lib/x509/pkcs7.c, lib/x509/privkey.c, lib/x509/privkey_pkcs8.c,
	lib/x509/time.c, lib/x509/tls_features.c, lib/x509/verify-high.c,
	lib/x509/verify.c, lib/x509/x509.c, lib/x509/x509_ext.c,
	lib/x509/x509_write.c, m4/hooks.m4, src/certtool-cfg.c,
	src/certtool.c, src/cli.c, src/danetool.c, src/list.h,
	src/ocsptool-common.c, src/ocsptool.c, src/pkcs11.c, src/serv.c,
	src/tests.c, tests/auto-verify.c, tests/cert-key-exchange.c,
	tests/cert-tests/Makefile.am, tests/certificate_set_x509_crl.c,
	tests/chainverify.c, tests/common-cert-key-exchange.c,
	tests/conv-utf8.c, tests/crl-basic.c, tests/crlverify.c,
	tests/crq-basic.c, tests/crq_key_id.c,
	tests/custom-urls-override.c, tests/custom-urls.c, tests/dane.c,
	tests/dtls-handshake-versions.c, tests/dtls-max-record.c,
	tests/dtls-rehandshake-anon.c, tests/dtls-rehandshake-cert-2.c,
	tests/dtls-rehandshake-cert-3.c, tests/dtls-rehandshake-cert.c,
	tests/dtls-sliding-window.c, tests/dtls/dtls-stress.c,
	tests/eagain-common.h, tests/fallback-scsv.c,
	tests/handshake-false-start.c, tests/handshake-versions.c,
	tests/hostname-check.c, tests/key-material-dtls.c,
	tests/key-usage.c, tests/mini-cert-status.c,
	tests/mini-chain-unsorted.c, tests/mini-dtls-heartbeat.c,
	tests/mini-dtls-large.c, tests/mini-dtls-lowmtu.c,
	tests/mini-dtls-mtu.c, tests/mini-eagain-dtls.c,
	tests/mini-eagain.c, tests/mini-emsgsize-dtls.c, tests/mini-etm.c,
	tests/mini-extension.c, tests/mini-global-load.c,
	tests/mini-key-material.c, tests/mini-record.c,
	tests/mini-rsa-psk.c, tests/mini-session-verify-function.c,
	tests/mini-supplementaldata.c, tests/mini-x509-2.c,
	tests/mini-x509-callbacks-intr.c, tests/mini-x509-callbacks.c,
	tests/mini-x509-cas.c, tests/mini-x509-default-prio.c,
	tests/mini-x509-dual.c, tests/mini-x509.c,
	tests/name-constraints-ip.c, tests/ocsp-tests/Makefile.am,
	tests/ocsp.c, tests/openpgp-auth.c, tests/openpgp-auth2.c,
	tests/openpgpself.c, tests/pgps2kgnu.c, tests/pkcs12_s2k.c,
	tests/pkcs12_s2k_pem.c, tests/pkcs12_simple.c,
	tests/pkcs8-key-decode.c, tests/prf.c,
	tests/rehandshake-ext-secret.c,
	tests/rehandshake-switch-cert-allow.c,
	tests/rehandshake-switch-cert-client-allow.c,
	tests/rehandshake-switch-cert-client.c,
	tests/rehandshake-switch-cert.c, tests/rehandshake-switch-psk-id.c,
	tests/rehandshake-switch-srp-id.c, tests/resume-dtls.c,
	tests/resume-with-false-start.c, tests/resume.c,
	tests/rsa-encrypt-decrypt.c, tests/send-client-cert.c,
	tests/session-export-funcs.c, tests/simple.c,
	tests/slow/cipher-override.c, tests/slow/cipher-override2.c,
	tests/srp.c, tests/test-chains.h, tests/tls-max-record.c,
	tests/tls-rehandshake-cert-2.c, tests/tls-rehandshake-cert.c,
	tests/tlsfeature-crt.c, tests/tlsfeature-ext.c, tests/utils-adv.c,
	tests/utils.c, tests/version-checks.c, tests/windows/cng-windows.c,
	tests/windows/crypt32.c, tests/x509-extensions.c,
	tests/x509cert-tl.c, tests/x509cert.c, tests/x509dn.c,
	tests/x509sign-verify.c, tests/x509sign-verify2.c: several spacing
	fixes to keep syntax-check happy

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/suite/testrandom.sh: avoid the usage of '-a' and '-o' bash
	options This keeps syntax-check happy.

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/str.c, src/certtool-cfg.c: avoid the usage of strncpy

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/socket.c: removed signal.h from files that wasn't used at

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* CONTRIBUTING.md, doc/cha-gtls-app.texi, guile/src/core.c,
	libdane/dane.c: doc update

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/ip.c: gnutls_x509_cidr_to_rfc5280: removed double
	semi-colon

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/system.c, lib/system/certs.c, lib/system/fastopen.c,
	lib/system/sockets.c, lib/system/threads.c, lib/x509/pkcs12_encr.c,
	lib/x509/pkcs7-output.c, lib/x509/time.c, lib/x509/x509_ext.c: 
	removed c-ctype.h from files that wasn't used at

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac: configure.ac: quote parameters when needed

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/extras/hex.c, lib/nettle/int/dsa-keygen-fips186.c,
	lib/nettle/int/dsa-validate.c,
	tests/pkcs11/pkcs11-import-url-privkey.c,
	tests/pkcs11/pkcs11-pubkey-import-ecdsa.c,
	tests/pkcs11/pkcs11-pubkey-import-rsa.c: removed assert.h from files
	that wasn't used at

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* po/POTFILES.in: POTFILES: added libdane files

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/tpmtool-args.def, tests/suite/testpkcs11.sh: doc update

2016-09-11  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* src/benchmark-cipher.c, tests/pkcs11/pkcs11-mock.c: tests/tools:
	avoid non-null check before free()

2016-09-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/latex/gnutls.tex: latex manual: added backwards compatibility
	options

2016-09-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: windows DLL builds now include all
	required dependencies Also improved naming conventions for builds

2016-09-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/system/inet_ntop.c: inet_ntop4: casted signed/unsigned
	comparison

2016-09-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/system.h: system.h: undefine macros before defining them

2016-09-10  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509_b64.c: _gnutls_fbase64_decode: use memsub macro instead
	of casts

2016-09-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli.c: gnutls-cli: use gnutls_set_default_priority if no
	priorities are given

2016-09-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/serv-args.def: gnutls-serv: removed '...' from documentation That caused caused problems in generated manpage.

2016-09-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure: better document the random generator
	variant used

2016-09-08  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: released 3.5.4

2016-09-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* .gitlab-ci.yml: .gitlab-ci.yml: corrected wrong operation in
	minimal build

2016-09-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files

2016-09-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS, lib/x509/ip.c: doc update

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, m4/hooks.m4: bumped versions

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am, tests/cert-tests/pkcs12-utf8: tests:
	do not run pkcs12-utf8 under windows This test required to pass UTF8 data under command line, and that
	doesn't seem to work under windows.

2016-09-07  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/iconv.c: _gnutls_ucs2_to_utf8: corrected use of
	WideCharToMultiByte in windows

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/conv-utf8.c: tests: added debugging info in conv-utf8

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/name-constraints-ip.c: tests: don't build
	cmocka tests with libutils - they conflict

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: keep config.log in windows builds

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: corrected typo for libidn
	installation in windows64

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: install our internal cmocka for
	windows

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/conv-utf8.c: tests: added unit tests of
	_gnutls_utf8_to_ucs2 and _gnutls_ucs2_to_utf8

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/libgnutls.map: libgnutls.map: export _gnutls_utf8_to_ucs2 and
	_gnutls_ucs2_to_utf8 for testing

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs12_encr.c: pkcs12: enhanced to allow encrypting using
	UCS2 passwords That is use _gnutls_utf8_to_ucs2() to convert the provided password
	to UCS2.

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/iconv.c: _gnutls_ucs2_to_utf8: fixed null termination
	check in windows code

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system.h, lib/system/iconv.c: Added _gnutls_utf8_to_ucs2() This function allows to convert between UTF8 to UCS2 big-endian.

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am, tests/cert-tests/pkcs12-utf8: tests:
	added tests for PKCS#12 decoding with UTF8 passwords

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/pkcs7-crypt.c: pkcs7 encryption: corrected memory leaks

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* Makefile.am: Makefile: local-code-coverage-output always succeeds

2016-09-02  Martin Ukrop <mukrop@redhat.com>

	* lib/x509/name_constraints.c, tests/name-constraints-ip.c: x509:
	Adjust IP name constraints behavior - Modified IPv4/IPv6 interaction in name constraints -- IPv4 and
	IPv6 no have empty intersection (previously: were treated
	independently).  - Current behavior is more conservative -- in case of IPv4
	constraint cert, subcerts will not be able to have IPv6 addresses.  - Tests updated accordingly.  - Behavior now matches NSS.

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/suite/testpkcs11.sh: tests: added checks to verify behavior
	in writing pkcs11 objects That is, verify that private keys are marked as private by default,
	and public objects are marked as non-private by default.

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/pkcs11.c: p11tool: eliminated memory leak in --list options

2016-09-06  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/p11tool-args.def, src/p11tool.c: p11tool: do not mark written
	objects as private by default That is, when --mark-private or --no-mark-private are not specified,
	set non-private for public objects and private for private ones.

2016-09-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-09-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/minitasn1/libtasn1.h, lib/minitasn1/parser_aux.c: minitasn1:
	updated to latest git version

2016-09-05  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/pk.c: _gnutls_encode_ber_rs_raw: simplified That is, use a single allocation for temporary data.

2016-09-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: use fedora24 with address
	sanitizer The fix in fbb9618b25b77c65e24a6ce224d53bc9a0b81457 addresses the
	problems with asan in fedora24.

2016-09-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/slow/Makefile.am: tests: use LSAN_OPTIONS
	instead of ASAN_OPTIONS New versions of address sanitizer do not parse this file otherwise.

2016-09-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-09-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/pkcs11/softhsm.h: tests: corrected detection of 64-bit
	systems in softhsm.h

2016-09-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/pkcs11/pkcs11-ec-privkey-test.c: tests:
	added check for PKCS#11 signature validity That is, tests whether our generated DSASignatureValue with PKCS#11
	contains r, s values that are non-negative, i.e., are zero padded
	when necessary. This utilizes _gnutls_decode_ber_rs_raw().

2016-09-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/libgnutls.map, lib/pk.c, lib/pk.h: Introduced helper function
	_gnutls_decode_ber_rs_raw()

2016-09-03  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/pk.c: _gnutls_encode_ber_rs_raw: zero-pad values when
	necessary This addresses issue when encoding values obtained via PKCS#11 which
	may not be necessarily padded.  Resolves #122

2016-09-03  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/cert-tests/template-test: tests: template-test: use uniform
	way to detect 32-bit systems

2016-09-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml, tests/pkcs11/softhsm.h: .gitlab-ci.yml: use the
	gitlab.com shared runners This removes the need to administer custom runners (except for the
	FreeBSD runner which cannot run under Linux), makes the testing on
	other platforms such as Debian simpler, and allows merge requests to
	pass through the CI.

2016-08-30  David Woodhouse <David.Woodhouse@intel.com>

	* lib/dtls-sw.c, lib/gnutls_int.h, tests/dtls-sliding-window.c,
	tests/mini-dtls-record.c: Import DTLS sliding window validation from
	OpenConnect ESP code In this implementation, the end of the sliding window is always
	advanced to the latest received packet, and we accept up to 64
	packets before that one. We no longer refuse to accept packets
	because they are *too* far ahead of what we've already seen.  Some of the test cases are fixed up accordingly.  This matches the code in OpenConnect esp-seqno.c at commit 314ac65.

2016-08-31  Jussi Kukkonen <jussi.kukkonen@intel.com>

	* src/Makefile.am: tools: Use correct include dir with minitasn This allows compiling certtool without libtasn headers.

2016-08-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/rnd-windows.c: nettle: removed unused variable in
	windows rng

2016-08-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: don't run danetool.sh when not compiled
	with dane support

2016-08-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-dtls-record.c: tests: mini-dtls-record: modified
	expected order to account for new SW behavior

2016-08-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/dtls-sw.c: dtls: ensure that the DTLS window doesn't get
	stalled That is ensure that it is forwarded at least one place if more than
	16 packets have been received since the first one.

2016-08-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/dtls-sliding-window.c: tests: enhance the DTLS window unit
	test to account for lost packets This adds tests for cases where many lost packets are encountered,
	such as 50% of the packets received, as well as 3 consequent packets
	being lost.

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* README.md: README.md: added coverage report [ci skip]

2016-08-28  David Woodhouse <dwmw2@infradead.org>

	* lib/x509/pkcs12.c: gnutls_pkcs12_simple_parse: set the key value
	to null on failure

2016-08-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/ocsp.c: tests: added basic operational check of
	gnutls_ocsp_resp_get_single()

2016-08-28  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/ocsp.c: gnutls_ocsp_resp_get_single: reorganized function
	to eliminate memory leaks Simplified and optimized the function operation, by removing
	unecessary memory allocations, as well as eliminate memory leaks on
	certain error cases.

2016-08-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/ocsp.c: ocsp: corrected the comparison of the serial size
	in OCSP response Previously the OCSP certificate check wouldn't verify the serial
	length and could succeed in cases it shouldn't.  Reported by Stefan Buehler.

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli.c, src/ocsptool-common.c, src/socket.c: tools: eliminated
	memory leaks in deinitialization

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli-debug.c, src/cli.c, src/danetool.c,
	src/ocsptool-common.c, src/socket.c, src/socket.h: tools: allow
	socket_bye() to be used for non-polite terminations

2016-08-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/ocsp-tests/Makefile.am,
	tests/ocsp-tests/suppressions.valgrind: tests: added
	suppressions.valgrind in ocsp-tests

2016-08-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-08-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am,
	tests/key-tests/data/pkcs8-pbes1-des-md5.pem,
	tests/key-tests/pkcs8-decode: tests: added check for the decoding of
	pbes1-des-md5 key

2016-08-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/Makefile.am, lib/x509/pkcs12.c, lib/x509/pkcs12_bag.c,
	lib/x509/pkcs7-crypt.c, lib/x509/pkcs7_int.h,
	lib/x509/privkey_pkcs8.c, lib/x509/privkey_pkcs8_pbes1.c,
	lib/x509/x509_int.h: pkcs8: cleaned up PKCS#8 decoding from common
	code with PKCS#7

2016-08-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/x509.h, lib/pkix.asn, lib/pkix_asn1_tab.c,
	lib/x509/Makefile.am, lib/x509/privkey_pkcs8.c,
	lib/x509/privkey_pkcs8_pbes1.c, lib/x509/x509_int.h: pkcs8: added
	support for decryption with PBES1-DES-CBC-MD5 While this is a legacy (and insecure) cipher combination it is the
	default output of openssl up until the 1.0.2 version. We introduce
	this option to allow decrypting private keys from these versions of
	openssl.

2016-08-25  raspa0 <raspa0@protonmail.com>

	* src/pkcs11.c: fix memleak in pkcs11_get_random

2016-08-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/ocsptool-common.c, src/ocsptool.c: ocsptool: reduce memory
	leaks on execution

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/ocsp-tests/Makefile.am,
	tests/ocsp-tests/ocsp-must-staple-connection,
	tests/ocsp-tests/ocsp-tls-connection: tests: enable
	ocsp-must-staple-connection check

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/global.c: doc: be more explicit about the usage of
	gnutls_global_init/deinit [ci skip]

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/pkcs8-decode: tests: don't use piped tee in
	pkcs8-decode It would prevent error codes from being detected in the tests.

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/socket.c: ocsptool: corrected bug in session establishment

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/ocsp-tests/ocsp-tls-connection: tests: ocsp-tls-connection:
	no longer check for netcat; it was not needed

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am,
	tests/key-tests/data/pkcs8-pbes2-sha256.pem,
	tests/key-tests/pkcs8-decode: tests: added decoding of key with
	pbes2 and SHA256 PRF

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS, lib/algorithms.h, lib/algorithms/mac.c, lib/gnutls_int.h,
	lib/includes/gnutls/gnutls.h.in, lib/libgnutls.map,
	lib/x509/pkcs12.c, lib/x509/privkey_pkcs8.c, lib/x509/x509_int.h: 
	Added support for decrypting PKCS#8 files which use HMAC-SHA256 as
	PRF This improves compatibility with new openssl versions.

2016-08-24  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/privkey_openssl.c: Ported openssl format fix from
	openconnect Patch by David Woodhouse

2016-08-24  raspa0 <raspa0@protonmail.com>

	* src/pkcs11.c: src/pkcs11.c: fix mech_list out-of-bounds check

2016-08-15  Philippe Proulx <eeppeliteloop@gmail.com>

	* lib/record.c: gnutls_record_recv(): doc: push -> pull Signed-off-by: Philippe Proulx <eeppeliteloop@gmail.com>

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/rnd-linux.c: rnd-linux: added check for SYS_getrandom
	being defined This allows to compile the getrandom() code in old Linux systems
	which do not have the system call defined.

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* libdane/Makefile.am: libdane: include minitasn1 headers

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli.c: gnutls-cli: do not exit if fast open is not supported

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/socket.c: gnutls-cli: added bufferring in starttls read of
	packets

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/starttls-ftp.txt, tests/starttls.sh: 
	tests: added basic test of STARTTLS over FTP for gnutls-cli

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* README.md, tests/Makefile.am, tests/starttls-smtp.txt,
	tests/starttls.sh: tests: added basic starttls functionality testing
	on gnutls-cli

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/socket.c: gnutls-cli: exit with error code 2 on starttls
	errors

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/fastopen.sh: tests: fixed fastopen.sh to operate from cmd

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli.c, src/socket.c, src/socket.h: gnutls-cli: fixed the
	behavior when --starttls or --starttls-proto is given The change of moving the handshake process as part of the socket
	establishment broke the starttls functionality in gnutls-cli. This
	change fixes that functionality.  Reported by Andreas Metzler.

2016-08-19  SUMIT AGGARWAL <aggarwal.s@samsung.com>

	* src/benchmark-cipher.c, src/srptool.c: Fix HANDLE_LEAK and memory
	leak issues.

2016-08-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/cli.c, src/socket.c: gnutls-cli: print 'Handshake was
	completed' The change of moving the handshake process as part of the socket
	establishment, prevented the text 'Handshake was completed' from
	being printed as part of a successful handshake. That message was
	used by applications like gnus which use gnutls-cli. This patch
	reverts that change and prints that message on successful
	handshakes.

2016-08-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, tests/Makefile.am, tests/cert-tests/Makefile.am,
	tests/{openpgp-certs => cert-tests/data}/ca-public.gpg,
	tests/{openpgp-certs => cert-tests/data}/ca-secret.gpg,
	tests/{openpgp-certs =>
	cert-tests/data}/srv-public-127.0.0.1-signed.gpg,
	tests/{openpgp-certs => cert-tests/data}/srv-public-all-signed.gpg,
	tests/{openpgp-certs =>
	cert-tests/data}/srv-public-localhost-signed.gpg,
	tests/{openpgp-certs => cert-tests/data}/srv-public.gpg,
	tests/{openpgp-certs => cert-tests/data}/srv-secret.gpg,
	tests/{openpgp-certs/testcerts => cert-tests/openpgp-certs},
	tests/{openpgp-certs/testselfsigs => cert-tests/openpgp-selfsigs},
	tests/openpgp-certs/Makefile.am: tests: openpgp-certs tests were
	moved to cert-tests

2016-08-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/crypto-api.c: gnutls_key_generate: fail if the state of the
	library is invalid Suggested by Stephan Mueller.

2016-08-10  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-dtls-hello-verify.c: tests: mini-dtls-hello-verify:
	ignore SIGPIPE to avoid unexpected crashes Resolves: #119

2016-08-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/ext/safe_renegotiation.c, lib/includes/gnutls/gnutls.h.in: 
	gnutls_safe_renegotiation_status: changed return type to unsigned

2016-08-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-08-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/long-session-id.c, tests/pkcs11/pkcs11-combo.c,
	tests/pkcs12_simple.c: tests: removed unused variables from tests

2016-08-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-06-23  Martin Ukrop <mukrop@redhat.com>

	* .gitignore, tests/Makefile.am, tests/name-constraints-ip.c,
	tests/test-chains.h: tests: Add tests for X509 IP constraints - Add dedicated test file name-constraints-ip for IP tests.  - Test the following:   * Generation and saving of valid name constraints.    * Trying to save invalid IP constraints.    * Reading the saved constraints.    * constraints_check() calls for both IPv4 and IPv6.    * IP constraints intersection (simple, empty, mediocre,
	  complicated).  * IPv4/IPv6 constraints interaction and various corner cases.  - IPs/CIDRs are printed in logs in case of failure.  - Add 2 new chain tests (positive, negative).  - Add generated test executable to ignored files.  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-06-29  Martin Ukrop <mukrop@redhat.com>

	* lib/x509/ip.c, lib/x509/name_constraints.c: x509: Add support for
	IP constraints - IP constraints are now checked against the subject alternative   name field.  - Implemented IP name constraints merging.  - Added IP constraints validity checking during loading and getting   the name constraints object from the user.  - Add a convenience function name_constraints_node_new that
	  allocates a name constraints node and sets its fields. Use this new
	  function where applicable.  - Add documentation for is_nc_empty,
	  _gnutls_name_constraints_node_free,
	_gnutls_name_constraints_intersect.  - Small improvements elsewhere (polishing).  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-08-03  Martin Ukrop <mukrop@redhat.com>

	* .gitignore, tests/Makefile.am, tests/{ip-in-cidr.c => ip-utils.c}: 
	tests: Add more IP conversion unit tests - Renamed ip-in-cidr test to ip-utils.  - Added built binary to .gitignore.  - Added new tests for gnutls_x509_cidr_to_rfc5280.  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-08-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/ip-in-cidr.c: tests: added unit test for
	ip_in_cidr function

2016-06-29  Martin Ukrop <mukrop@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in,
	lib/includes/gnutls/x509.h, lib/libgnutls.map,
	lib/x509/Makefile.am, lib/x509/ip-in-cidr.h, lib/x509/ip.c,
	lib/x509/ip.h, lib/x509/name_constraints.c, lib/x509/output.c,
	src/certtool-cfg.c: x509: Separate out IP handling functions - Moved IP/CIDR to string conversion functions into separate   header and export privately for the use in tests.  - Placed ip_in_cidr() into separate header for easy testing - Add publicly available function to convert text CIDR to RFC5280   format for the use in name constraints extension.  - certtool: Use GnuTLS exported CIDR functions instead of local
	ones.  - Export mask_to_prefix, mask_ip for internal GnuTLS use.  - Introduce new error value (malformed cidr) and add to description   functions in errors.c.  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-06-23  Martin Ukrop <mukrop@redhat.com>

	* tests/name-constraints.c, tests/test-chains.h: tests: Add corner
	case tests for name constraints, improve doc - Added corner case test suite for DNS name constraints.  - Documentation update in chain tests.  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-07-08  Martin Ukrop <mukrop@redhat.com>

	* .gitignore: Add more ignored files * .tmp and .swp for text editor files * Makefile.user created by Qt Creator * gl/tests/ctype.h as it is generated from ctype.h.in Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-08-08  Stefan Sørensen <stefan.sorensen@spectralink.com>

	* tests/cert-common.h, tests/keylog-env.c,
	tests/send-client-cert.c, tests/set_x509_key.c,
	tests/set_x509_key_file_der.c, tests/set_x509_key_file_ocsp.c,
	tests/set_x509_key_mem.c, tests/x509-cert-callback-legacy.c,
	tests/x509-cert-callback.c, tests/x509cert.c: Change ca3 and related
	certificate to include an intermediate CA in the chain.  Also update a bunch of test-cases to support chains with an
	intermediate CA.  Signed-off-by: Stefan Sørensen <stefan.sorensen@spectralink.com>

2016-08-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-common.h, tests/x509cert.c: Revert "tests: check
	gnutls_certificate_get_x509_crt with more than one certificates" This reverts commit f7d884720b128ef86f6b9dc9fc498be89faf1732.

2016-08-09  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/srp.c: tests: do not run srp test when no SRP support is
	compiled in

2016-08-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/alpn-server-prec.c, tests/client-fastopen.c,
	tests/custom-urls-override.c, tests/custom-urls.c,
	tests/dtls-client-with-seccomp.c, tests/dtls-rehandshake-anon.c,
	tests/dtls-rehandshake-cert-2.c, tests/dtls-rehandshake-cert-3.c,
	tests/dtls-rehandshake-cert.c, tests/dtls-with-seccomp.c,
	tests/fallback-scsv.c, tests/key-material-dtls.c,
	tests/key-material-set-dtls.c, tests/long-session-id.c,
	tests/mini-alpn.c, tests/mini-cert-status.c,
	tests/mini-chain-unsorted.c, tests/mini-dtls-discard.c,
	tests/mini-dtls-fork.c, tests/mini-dtls-heartbeat.c,
	tests/mini-dtls-hello-verify-48.c, tests/mini-dtls-hello-verify.c,
	tests/mini-dtls-large.c, tests/mini-dtls-lowmtu.c,
	tests/mini-dtls-mtu.c, tests/mini-dtls-pthread.c,
	tests/mini-dtls-record-asym.c, tests/mini-dtls-record.c,
	tests/mini-dtls-srtp.c, tests/mini-dtls0-9.c, tests/mini-etm.c,
	tests/mini-handshake-timeout.c, tests/mini-key-material.c,
	tests/mini-loss-time.c, tests/mini-overhead.c,
	tests/mini-record-2.c, tests/mini-record-failure.c,
	tests/mini-record-range.c, tests/mini-record-retvals.c,
	tests/mini-record.c, tests/mini-server-name.c,
	tests/mini-termination.c, tests/mini-tls-nonblock.c,
	tests/no-signal.c, tests/openpgp-auth.c, tests/openpgp-auth2.c,
	tests/openpgp-callback.c, tests/prf.c, tests/resume-dtls.c,
	tests/resume.c, tests/sign-md5-rep.c, tests/srp.c,
	tests/status-request-missing.c, tests/status-request-ok.c,
	tests/status-request.c, tests/tls-client-with-seccomp.c,
	tests/tls-rehandshake-cert-2.c, tests/tls-with-seccomp.c,
	tests/tlsext-decoding.c, tests/utils.h, tests/x509dn.c: tests: moved
	child status error checking code in utils.h

2016-08-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/latex/Makefile.am, doc/latex/macros.tex: latex: updated
	sources for new functions

2016-08-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* doc/Makefile.am, doc/manpages/Makefile.am, symbols.last: updated
	auto-generated files

2016-08-09  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: released 3.5.3

2016-08-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/socket.h, lib/system/fastopen.c, src/cli.c,
	tests/client-fastopen.c: gnutls_transport_set_fastopen: added flags
	options This will allow minor modifications to the semantics of the function
	in the future, without introducing a new API.

2016-08-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-08-08  Stefan Sørensen <stefan.sorensen@spectralink.com>

	* lib/x509/pkcs12.c: Fix gnutls_pkcs12_simple_parse to always
	extract the complete chain gnutls_pkcs12_simple_parse was only collecting extra certificates
	that was possible elements of the certificate chain when the
	extra_certs argument was not NULL. Fix by allways collecting all the
	certificates, any unneeded certificates are released before
	returning if extra_certs is NULL anyway.  Signed-off-by: Stefan Sørensen <stefan.sorensen@spectralink.com>

2016-08-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-common.h, tests/x509cert.c: tests: check
	gnutls_certificate_get_x509_crt with more than one certificates This would detect the issue in the "Fix invalid pointer operation in
	gnutls_certificate_get_x509_crt"

2016-08-08  Stefan Sørensen <stefan.sorensen@spectralink.com>

	* tests/x509cert.c, tests/x509dn.c, tests/x509self.c: tests: Use
	common ca3 test certificates in x509cert, x509dn and x509self tests.  Signed-off-by: Stefan Sørensen <stefan.sorensen@spectralink.com>

2016-08-08  Stefan Sørensen <stefan.sorensen@spectralink.com>

	* tests/cert-common.h: tests: Remove zero-termination of
	gnutls_datum encapsulated certificates This allows for memcmp comparison with certificates after
	processing.  Signed-off-by: Stefan Sørensen <stefan.sorensen@spectralink.com>

2016-08-08  Stefan Sørensen <stefan.sorensen@spectralink.com>

	* lib/x509.c: Fix invalid pointer operation in
	gnutls_certificate_get_x509_crt The access to the allocated crt_list variable was missing a pointer
	dereference, leading to memory corruption for any certificate list
	with more than one element.  Signed-off-by: Stefan Sørensen <stefan.sorensen@spectralink.com>

2016-08-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, tests/Makefile.am, tests/key-tests/Makefile.am,
	tests/key-tests/data/key-illegal.pem,
	tests/key-tests/data/p8key-illegal.pem,
	tests/key-tests/illegal-rsa, tests/rsa-illegal-import.c: tests:
	added check for errors when importing illegal RSA keys

2016-08-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/privkey.c, lib/x509/privkey_pkcs8.c: x509: call the fixup
	functions after loading private keys That way we can better report errors which relate to illegal
	parameters being detected.

2016-08-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/nettle/pk.c: nettle: use rsa_*_key_prepare on key import Previously we calculated the size of the key directly, but by using
	the rsa_*_key_prepare we benefit from any checks that may be
	introduced in the future. Specifically any checks for invalid public
	keys (e.g., keys that may crash the underlying gmp functions).  This patch avoids calling rsa_private_key_prepare every time we
	construct a nettle private key struct, because this function
	requires a bigint multiplication. We call that function once on
	private key import.

2016-08-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* tests/key-tests/Makefile.am: tests: added missing backslash in
	key-tests Makefile

2016-08-08  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/pk.c: Revert "nettle: use rsa_*_key_prepare" This reverts commit c801a15bca9ea8f3f7abd4be48bebd36c54eeba2.

2016-08-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/includes/gnutls/gnutls.h.in: gnutls.h: moved all compatibility
	defines outside the enum

2016-08-07  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* configure.ac, m4/hooks.m4: prepared for release 3.5.3

2016-08-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-record-2.c, tests/mini-record-failure.c,
	tests/mini-record-retvals.c: tests: use gnutls_record_set_timeout
	instead of kill child processes That way we avoid issues like #118 which are caused by killing the
	child process, and we also avoid deadlocks by making sure that recv
	will terminate after a long delay.

2016-08-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-record.c: tests: mini-record modify in a way to be more
	fail safe That is, do not kill the child, but instead switch the roles of
	child and parent, and add a timeout on recv to avoid infinite
	delays.  Relates: #118

2016-08-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/pkcs11_int.h, lib/x509/verify-high2.c: pkcs11:
	is_object_pkcs11_url -> is_pkcs11_url_object Renamed function for clarity.

2016-08-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/mini-record.c: tests: ignore sigpipe in mini-record

2016-08-05  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/fips.c, lib/includes/gnutls/gnutls.h.in: 
	gnutls_fips140_mode_enabled: changed return type to unsigned

2016-08-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* CONTRIBUTING.md: doc: updated contribution guide with more info on
	test suite [ci skip]

2016-08-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/pkcs11.h, lib/pkcs11_privkey.c: 
	gnutls_pkcs11_privkey_status: return type changed to unsigned

2016-08-04  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/cha-bib.texi, doc/cha-gtls-app.texi: doc: added section on
	SCTP protocol [ci skip]

2016-08-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/client-fastopen.c: tests: client-fastopen: removed seccomp
	conditional

2016-08-02  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/fastopen.c: fastopen: improved error checking at
	connect()

2016-08-01  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/pk.c: nettle: use rsa_*_key_prepare Previously we calculated the size of the key directly, but by using
	the rsa_*_key_prepare we benefit from any checks that may be
	introduced in the future. Specifically any checks for invalid public
	keys (e.g., keys that may crash the underlying gmp functions).

2016-07-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/system/fastopen.c: gnutls_transport_set_fastopen: doc update

2016-07-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-07-29  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/rnd-linux.c: getrandom: use SYS_getrandom instead of
	__NR_getrandom These are identical definitions, but according to syscall()
	SYS_getrandom is the expected value.

2016-07-27  Martin Ukrop <mukrop@redhat.com>

	* lib/x509/name_constraints.c: x059: Fix asymmetry in name
	constraints intersection - In _gnutls_name_constraints_intersect, if *_nc had a node of some
	type not present in _nc2, this was preserved. However, if it was
	vice versa (_nc2 having a type not present in *_nc), this node was
	discarded.  - This is now fixed.  - Removed redundant return value check that was accidentally left
	when refactoring from set_datum to explicit NULL setting.  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-07-26  Martin Ukrop <mukrop@redhat.com>

	* tests/test-chains.h: tests: Add and improve chain tests - Add a new chaintest testing the symmetry of merging name
	constraints of different types.  - Rename old name_constraints_but_no_name test to match other name
	constraints tests.  - Improve chain description of older name constraints tests.  Signed-off-by: Martin Ukrop <mukrop@redhat.com>

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update [ci skip]

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure: do not generate makefiles in removed dirs

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/set_pkcs12_cred.c: tests: updated paths
	for new location of p12 files

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/safe-renegotiation/Makefile.am,
	tests/safe-renegotiation/suppressions.valgrind: tests: safe
	renegotiation tests are run from top dir

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/{srp/mini-srp.c => srp.c},
	tests/srp/Makefile.am: tests: srp tests moved outside subdir

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-tests/Makefile.am, tests/{sha2 =>
	cert-tests/data}/key-ca-dsa.pem, tests/{sha2 =>
	cert-tests/data}/key-ca.pem, tests/{sha2 =>
	cert-tests/data}/key-dsa.pem, tests/{sha2 =>
	cert-tests/data}/key-subca-dsa.pem, tests/{sha2 =>
	cert-tests/data}/key-subca.pem, tests/{sha2 =>
	cert-tests/data}/key-subsubca.pem, tests/{sha2 =>
	cert-tests/data}/key-user.pem, tests/cert-tests/sha2-dsa-test,
	tests/cert-tests/sha2-test, tests/sha2/Makefile.am,
	tests/sha2/sha2, tests/sha2/sha2-dsa: tests: moved sha2 tests into
	cert-tests/

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/ecdsa/Makefile.am, tests/ecdsa/ecdsa,
	tests/key-tests/Makefile.am, tests/{ecdsa =>
	key-tests/data}/bad-key.pem, tests/key-tests/ecdsa: tests: moved
	ecdsa tests to key-tests/

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/dsa/Makefile.am,
	tests/key-tests/Makefile.am, tests/{dsa =>
	key-tests/data}/cert.dsa.1024.pem, tests/{dsa =>
	key-tests/data}/cert.dsa.2048.pem, tests/{dsa =>
	key-tests/data}/cert.dsa.3072.pem, tests/{dsa =>
	key-tests/data}/dsa-pubkey-1018.pem, tests/{dsa =>
	key-tests/data}/dsa.1024.pem, tests/{dsa =>
	key-tests/data}/dsa.2048.pem, tests/{dsa =>
	key-tests/data}/dsa.3072.pem, tests/{dsa/testdsa => key-tests/dsa}: 
	tests: moved dsa tests into key-tests/

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/key-tests/Makefile.am,
	tests/{pkcs8-decode => key-tests/data}/enc2pkcs8.pem,
	tests/{pkcs8-decode => key-tests/data}/encpkcs8.pem,
	tests/{pkcs8-decode => key-tests/data}/openssl-3des.p8,
	tests/{pkcs8-decode => key-tests/data}/openssl-3des.p8.txt,
	tests/{pkcs8-decode => key-tests/data}/openssl-aes128.p8,
	tests/{pkcs8-decode => key-tests/data}/openssl-aes128.p8.txt,
	tests/{pkcs8-decode => key-tests/data}/openssl-aes256.p8,
	tests/{pkcs8-decode => key-tests/data}/openssl-aes256.p8.txt,
	tests/{pkcs8-decode => key-tests/data}/unencpkcs8.pem,
	tests/{pkcs8-decode/pkcs8 => key-tests/pkcs8-decode},
	tests/pkcs8-decode/Makefile.am,
	tests/pkcs8-decode/suppressions.valgrind: tests: moved pkcs8 tests
	to key-tests/

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/key-tests/Makefile.am, tests/key-tests/{ =>
	data}/ca-gnutls-keyid.pem, tests/key-tests/{ =>
	data}/ca-no-keyid.pem, tests/key-tests/{ =>
	data}/ca-weird-keyid.pem, tests/key-tests/{ =>
	data}/key-ca-1234.p8, tests/key-tests/{ => data}/key-ca-empty.p8,
	tests/key-tests/{ => data}/key-ca-null.p8, tests/key-tests/{ =>
	data}/key-ca.pem, tests/key-tests/{ => data}/key-ecc.p8,
	tests/key-tests/{ => data}/key-ecc.pem, tests/key-tests/{ =>
	data}/key-user.pem, tests/key-tests/{ => data}/openssl-key-ecc.p8,
	tests/key-tests/key-id, tests/key-tests/pkcs8: tests: key-tests:
	moved data files into data/ subdir

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-tests/Makefile.am,
	tests/{pkcs12-decode => cert-tests}/pkcs12,
	tests/pkcs12-decode/Makefile.am,
	tests/pkcs12-decode/suppressions.valgrind: tests: moved pkcs12 tests
	into cert-certs/ subdir

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore: more files to ignore

2016-07-28  Tim Rühsen <tim.ruehsen@gmx.de>

	* configure.ac: Require compiler to support C99

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-07-09  Tim Kosse <tim.kosse@filezilla-project.org>

	* tests/chainverify-unsorted.c: Add test for
	gnutls_x509_crt_list_import2 with flag
	GNUTLS_X509_CRT_LIST_FAIL_IF_UNSORTED.

2016-07-09  Tim Kosse <tim.kosse@filezilla-project.org>

	* lib/x509/crl.c: gnutls_x509_crl_list_import2 was ignoring the
	passed flags if all CTLs in the list fit within the initially
	allocated memory.

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/cert-session.c: gnutls_certificate_get_peers may return an
	unsorted list

2016-07-09  Tim Kosse <tim.kosse@filezilla-project.org>

	* lib/x509/x509.c: gnutls_x509_crt_list_import2 was ignoring the
	passed flags if all certificates in the list fit within the
	initially allocated memory.

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/x509_ext.c: x509: parse_tlsfeatures: move limit check at
	the point of addition This prevents appending failures when verifying chains on
	certificates which use the maximum allowed number of features.
	Suggested by Tim Kosse.

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/tlsfeature-ext.c: tests: removed irrelevant comment

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/tls_features.c: correct the sign type of integers in
	debug message Suggested by Tim Kosse

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify.c: verify_crt: simplified error setting based on suggestion by Tim Kosse.

2016-07-28  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/x509/verify.c: verify_crt: removed text on parameter no longer
	being present

2016-07-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/x509/name_constraints.c: x509: avoid using int declaration
	within a for-loop This addresses compilation problem with old compilers, and brings
	consistency as this type of declaration is not used in gnutls' code.

2016-07-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/global.c: gnutls_global_init/deinit: don't use any locking
	during constructor This ensures that there is no deadlock on unexpected errors, such as
	missing symbols (e.g., on lazy linking). Reported by Ludovic
	Courtès.

2016-07-27  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* lib/nettle/rnd-linux.c: rnd-linux: use better define check for
	linux systems

2016-07-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/prf.c: gnutls_prf: document when its output matches
	gnutls_prf_rfc5705

2016-07-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/session.c: doc: gnutls_session_set_id: added since

2016-07-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: keep the guile logs as artifacts
	on test suite failure

2016-07-27  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update

2016-07-20  David Walker <david.walker@vcatechnology.com>

	* lib/common.mk: Add extra dependency flags This fixes the build when the dependencies are split up during a
	cross-compile Resolves: #113

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/Makefile.am, lib/{system-keys-dummy.c =>
	system/keys-dummy.c}, lib/{system-keys-win.c => system/keys-win.c}: 
	moved system-keys-win.c and system-key-dummy.c under system/

2016-07-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/Makefile.am, lib/system.c, lib/system.h, lib/system/certs.c,
	lib/system/iconv.c, lib/{ => system}/inet_ntop.c, lib/{ =>
	system}/inet_pton.c, lib/system/sockets.c, lib/system/threads.c,
	lib/{ => system}/vasprintf.c: split system.c to various files under
	system/

2016-07-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/includes/gnutls/gnutls.h.in: gnutls.h: giovec_t
	is a typedef to iovec where that is available

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac, lib/nettle/rnd-linux.c, tests/Makefile.am,
	tests/rng-sigint.c: tests: added unit test for linux
	_rnd_get_system_entropy This tests whether the function can operate as expected while being
	interrupted by signals.

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/nettle/rnd-linux.c: getrandom: loop around getrandom to get
	the requested number of bytes This simplifies and enhanced the previous error handling code.

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* devel/README.ci-runners: README.ci-runners: document asan and
	ubsan tags

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am: tests: removed pkcs1-padding from subdirs

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitignore: .gitignore: more tests files to ignore

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* configure.ac: configure.ac: don't generate makefiles of moved
	tests

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/cert-tests/Makefile.am, tests/{pkcs1-padding =>
	cert-tests/data}/pkcs1-pad-broken.pem, tests/{pkcs1-padding =>
	cert-tests/data}/pkcs1-pad-broken2.pem, tests/{pkcs1-padding =>
	cert-tests/data}/pkcs1-pad-broken3.pem, tests/{pkcs1-padding =>
	cert-tests/data}/pkcs1-pad-ok.pem, tests/{pkcs1-padding =>
	cert-tests/data}/pkcs1-pad-ok2.pem, tests/{pkcs1-padding =>
	cert-tests}/pkcs1-pad, tests/pkcs1-padding/Makefile.am: tests:
	pkcs1-pad: moved to cert-tests

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/cert-tests/Makefile.am, tests/{userid =>
	cert-tests/data}/userid.pem, tests/{userid => cert-tests}/userid,
	tests/userid/Makefile.am: tests: userid test moved to cert-tests/

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/rsa-md5-collision/Makefile.am,
	tests/rsa-md5-collision/{rsa-md5-collision => rsa-md5-collision.sh}: 
	tests: rsa-md5-collision: run from top-level

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/record.c: doc: updated documentation for
	gnutls_transport_set_int*

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* doc/Makefile.am, doc/cha-bib.texi, doc/cha-functions.texi,
	doc/cha-gtls-app.texi, doc/doc.mk, doc/manpages/Makefile.am: doc:
	added section on reducing round-trips That discusses TCP fast open with gnutls_transport_set_fastopen(),
	and false start.

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/client-fastopen.c: tests: added test of
	gnutls_transport_set_fastopen

2016-07-25  Tim Ruehsen <tim.ruehsen@gmx.de>

	* tests/Makefile.am, tests/fastopen.sh: tests: added test of TCP
	fast open using gnutls-cli and gnutls-serv

2016-07-25  Tim Ruehsen <tim.ruehsen@gmx.de>

	* NEWS: doc update

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* src/Makefile.am, src/cli-debug.c, src/cli.c, src/common.c,
	src/common.h, src/danetool.c, src/ocsptool-common.c,
	src/ocsptool.c, src/socket.c, src/socket.h: tools: TLS handling has
	been incorporated into socket_open() This is of particular usage to the server IP address loop, since we
	can detect fast open errors and retry handshake to the next IP
	address.

2016-07-25  Tim Ruehsen <tim.ruehsen@gmx.de>

	* src/cli-args.def, src/cli.c, src/socket.c, src/socket.h: 
	gnutls-cli: added example usage of TCP fastopen It is enabled with the new --fastopen option.

2016-07-25  Tim Ruehsen <tim.ruehsen@gmx.de>

	* configure.ac, doc/Makefile.am, doc/manpages/Makefile.am,
	lib/Makefile.am, lib/buffers.c, lib/gnutls_int.h,
	lib/includes/Makefile.am, lib/includes/gnutls/socket.h,
	lib/libgnutls.map, lib/state.c, lib/system.c, lib/system.h,
	lib/system/fastopen.c: Support TCP Fast Open This introduces a new function gnutls_transport_set_fastopen().  Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>
	Signed-off-by: Tim Ruehsen <tim.ruehsen@gmx.de>

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* .gitlab-ci.yml: .gitlab-ci.yml: added asan tag for builds which
	require asan

2016-07-26  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/pkcs11/pkcs11-privkey-fork.c, tests/suppressions.valgrind: 
	tests: pkcs11-privkey-fork: added explicit pkcs11 deinitialization Also ignore known leaks for p11-kit.

2016-07-25  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* README.md: mention ubsan in README [ci skip]

2016-07-21  Nikos Mavrogiannopoulos <nmav@gnutls.org>

	* NEWS: doc update

2016-07-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* tests/Makefile.am, tests/keylog-env.c, tests/set_x509_key.c,
	tests/set_x509_key_file.c, tests/set_x509_key_file_der.c,
	tests/set_x509_key_file_ocsp.c, tests/set_x509_key_mem.c,
	tests/set_x509_pkcs12_key.c, tests/utils-adv.c, tests/utils.h: 
	tests: added checks for OCSP response file support That is, check the usability of the APIs for setting and using an
	ocsp response. This improves and makes more generic the test suite
	API and test_cli_serv() in particular.

2016-07-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/dtls.c: dtls: added a null pointer check in record_overhead According to my reading this check is unnecessary as in no case a
	null pointer can be encountered. However gcc6 warns about a null
	pointer derefence and thus adding it, to be safe.

2016-07-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/includes/gnutls/x509.h, lib/x509/hostname-verify.c: 
	gnutls_x509_crt_check_hostname*: use unsigned a return value This is to prevent issues to callers who may check for negative
	error values.

2016-07-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* NEWS: doc update [ci skip]

2016-07-22  Nikos Mavrogiannopoulos <nmav@redhat.com>

	* lib/errors.c, lib/includes/gnutls/gnutls.h.in,
	lib/session_pack.c, tests/resume-with-false-start.c: introduced:
